/* 
 * common.c Υإåե
 * common.h
 * shige
 * 12/27 2003
 * 
 * $Id: common.h,v 1.28 2017-03-28 17:47:37+09 shige Exp $
 */
#ifndef __COMMON_H__
#define __COMMON_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "auio.h"
#include "wavio.h"
#include "aiffio.h"

#include "error.h"

typedef union {
    AUdata au;
    WAVdata wav;
    AIFFdata aiff;
} SNDheader;

#define MAXChannel AUMAXChannel

enum {E_AU = 0, E_WAV, E_AIFF, E_UNKNOWN}; 

/* for SNDchheaderMASK() */
#define CH_MAGIC 0x0001
#define CH_FMCODE 0x0002
#define CH_CHANNEL 0x0004
#define CH_SMPLRATE 0x0008
#define CH_BLOCKSIZE 0x0010
#define CH_BITPERSMPL 0x0020
#define CH_BYTEPERSEC 0x0040
#define CH_ALL (CH_MAGIC | CH_FMCODE | CH_CHANNEL | CH_SMPLRATE \
		| CH_BLOCKSIZE | CH_BITPERSMPL | CH_BYTEPERSEC)
#define CH_BLOCKS 0x0080

/* for SNDgetmaxlevel() */
#ifndef Max
# define Max(a, b)  (((a) > (b)) ? (a) : (b))
#endif
#ifndef Abs
# define Abs(a)  Max((a), -(a))
#endif

#ifdef __COMMON_C__
# define EXTERN_COMMON 
#else
# define EXTERN_COMMON extern 
#endif

EXTERN_COMMON int getSNDheader(FILE *file, SNDheader *snd);
EXTERN_COMMON int putSNDheader(FILE *file, SNDheader *snd, int format);
EXTERN_COMMON int setSNDheader(SNDheader *snd, int format, int fmcode, 
			      int channel, double smplrate,
			      int bitpersmpl, long int blocks, 
			      int flags);
#ifdef __COMMON_C__
static double volweight(double t, double T, double t1, double t2,
			double svol, double evol);
#endif
EXTERN_COMMON int SNDputtrans(FILE *infile, FILE *outfile, 
			      SNDheader *snd, int format, 
			      long int olen, long int maxilen, 
			      double times, double t1, double t2, 
			      double svol[], double evol[]);
EXTERN_COMMON void SNDskipheader(FILE *infile, int format);
EXTERN_COMMON void SNDskip1chdata(FILE *infile, SNDheader *snd,
				  int format);
EXTERN_COMMON void SNDpass1chrawdata(FILE *infile, FILE *outfile, 
				     SNDheader *snd, int format);
EXTERN_COMMON void SNDputnull1ch(FILE *outfile, SNDheader *snd,
				 int format);
EXTERN_COMMON int SNDput1chleveldata(FILE *outfile, double data,
				     SNDheader *snd, int format);
EXTERN_COMMON double SNDget1chleveldata(FILE *infile, SNDheader *snd,
					int format);
EXTERN_COMMON int cpSNDheader(SNDheader *new, SNDheader *org,
			      int format);
EXTERN_COMMON int SNDblocksize(SNDheader *snd, int format);
EXTERN_COMMON int SNDbitpersmpl(SNDheader *snd, int format);
EXTERN_COMMON int SNDchannels(SNDheader *snd, int format);
EXTERN_COMMON int SNDchheaderMASK(SNDheader *snd1, SNDheader *snd2,
				  int format, int mask);
EXTERN_COMMON long int SNDblocks(SNDheader *snd, int format);
EXTERN_COMMON long int SNDdatalen(SNDheader *snd, int format);
EXTERN_COMMON long int SNDhlen(SNDheader *snd, int format);
EXTERN_COMMON double SNDsmplrate(SNDheader *snd, int format);
EXTERN_COMMON double SNDgetmaxlevel(FILE *infile, SNDheader *snd,
				    int format);
EXTERN_COMMON double SNDgetmaxlevelChannel(FILE *infile, SNDheader *snd,
					   int format,
					   double maxlevel[]);
#endif /* __COMMON_H__ */
