/* auconn, wavconn  (pathlist, extlist) ˴ؤ routine
 * shige
 * 09/30 2000
 * conf.c
 *
 * $Id: conf.c,v 1.21 2017-03-31 15:33:46+09 shige Exp $
 */
#ifndef __CONF_C__
#define __CONF_C__

#include "conf.h"

/* ########## data file path or ext list subroutine ########## */
/* ѥΥƥǥեȤ (pathlist, extlist, nullfile) */
int setsystemdefault(ConnOpt *opt)
{
    if (DEFAULTPathlist != NULL) {
	pathlistnum = updatelist(pathlist, pathlistnum, Maxpathlists,
				 DEFAULTPathlist, Maxpathlen);
	if (pathlistnum < 0) return pathlistnum;
    }
    if (DEFAULTExtlist != NULL) {
	extlistnum = updatelist(extlist, extlistnum, Maxextlists,
				DEFAULTExtlist, Maxextlen);
	if (extlistnum < 0) return extlistnum;
    }
    NULLFname = NULL;
    /* opt ΥǥեȤ ? */
    opt->addsp = 0;
    opt->pmode = 0;
    opt->pparam = 0;
    (opt->total).type = L_undefined;
    (opt->total).len = 0;
    (opt->head).type = L_undefined;
    (opt->head).len = 0;
    (opt->tail).type = L_undefined;
    (opt->tail).len = 0;
    opt->times = -1.0;
    return No_err;
}

/* Ķѿ (pathlist, extlist, nullfile) */
int loadenv(char *env[])
{
    int lenp, lene, lenn, j;

    lenp = strlen(DEFAULTPathEnvname);
    lene = strlen(DEFAULTExtEnvname);
    lenn = strlen(DEFAULTNULLFEnvname);
    for (j=0; env[j]!=NULL; j++)
      if (! strncmp(DEFAULTPathEnvname, env[j], lenp) 
	  && *(env[j] + lenp) == '=') {
	  pathlistnum = updatelist(pathlist, pathlistnum, Maxpathlists,
				   env[j] + lenp + 1, Maxpathlen);
	  if (pathlistnum < 0) return pathlistnum;
      } else if (! strncmp(DEFAULTExtEnvname, env[j], lene)
		 && *(env[j] + lene) == '=') {
	  extlistnum = updatelist(extlist, extlistnum, Maxextlists,
				  env[j] + lene + 1, Maxextlen);
	  if (extlistnum < 0) return extlistnum;
      } else if (! strncmp(DEFAULTNULLFEnvname, env[j], lenn)
		 && *(env[j] + lenn) == '=') {
	  if (strlen(env[j] + lenn + 1) >= Maxnullflen)
	    return Err_longconf;
	  if (NULLFname == NULL) NULLFname = nullfbuff;
	  strcpy(NULLFname, env[j] + lenn + 1);
      }
    return No_err;
}

/* conf եɤ߹ǥץ
 */
int loadconffile(char *fname, ConnOpt *opt)
{
    FILE *infile;
    char buff0[Maxbuff], buff[Ilast][Maxbuff], tmp[Maxbuff], *s;
    int ret, len, j, len1, len2;

    if ((infile = fopen(newfname(fname), "r")) == NULL) {
	/* if (verbose) fprintf("File [%s] is not found.\n", fname); */
	return Err_fopen;
    }
    /* ץʸ¸ν */
    for (j=0; j<Ilast; j++) buff[j][0] = '\0';
    /* ץʸ¸ */
    while (fgets(buff0, Maxbuff, infile) != NULL) {
	if ((len=strlen(buff0)) == Maxbuff - 1 && buff0[len - 1] != '\n')
	  return Err_longconf;
	buff0[len - 1] = '\0';
	if ((s = strtok(buff0, Confdelimiter)) == NULL 
	    || *s == Confcomment) continue;
	for (j=0; j<Ilast; j++) {
	    if (! strcmp(s, OptionNames[j])) {
		if ((s = strtok(NULL, Confdelimiter)) == NULL) 
		  return Err_conf;
		switch (OptionMode[j]) {
		case Moverride:
		    if (strlen(s) >= Maxbuff)
		      return Err_longconf;
		    strcpy(buff[j], s);
		    break;
		case Mappend:
#ifdef DEBUG5
		    fprintf(stderr, "DEBUG: (buff[%d], s)=([%s], [%s])\n",
			    j, buff[j], s); 
#endif
		    len1 = strlen(buff[j]); len2 = strlen(s);
		    if (len1 == 0) {
			if (len2 >= Maxbuff) return Err_longconf;
			strcpy(buff[j], s);
		    } else {
			if (len1 + len2 + 1 >= Maxbuff)
			  return Err_longconf;
			buff[j][len1] = Listdelimiter;
			strcpy(buff[j] + len1 + 1, s);
#ifdef DEBUG5
			fprintf(stderr, "DEBUG: buff[%d]=[%s]\n", j, buff[j]); 
#endif
		    }
		    break;
		case Mprepend:
		    len1 = strlen(buff[j]); len2 = strlen(s);
		    if (len1 + len2 + 1>= Maxbuff) return Err_longconf;
		    if (len1 == 0) {
			if (len2 >= Maxbuff) return Err_longconf;
			strcpy(buff[j], s);
		    } else {
			strcpy(tmp, buff[j]);
			strcpy(buff[j], s);
			buff[j][len2] = Listdelimiter;
			strcpy(buff[j] + len2 + 1, tmp);
		    }
		    break;
		case Mnochange:
		default:
		    break;
		}
		break;
	    }
	}
	if (j>=Ilast) return Err_conf;
    }
    fclose(infile);

    /* ƥץ */
    for (j=0; j<Ilast; j++) {
	switch (j) {
	case Ipath: 
	    pathlistnum = updatelist(pathlist, pathlistnum, 
				     Maxpathlists, buff[j], 
				     Maxpathlen);
	    if (pathlistnum < 0) return pathlistnum;
	    break;
	case Iext: 
	    extlistnum = updatelist(extlist, extlistnum, 
				    Maxextlists, buff[j], Maxextlen);
	    if (extlistnum < 0) return extlistnum;
	    break;
	case Inullfile: 
	    if ((len = strlen(buff[j])) == 0 || buff[j][0] == '-') 
	      NULLFname = NULL; 
	    else if (len >= Maxnullflen) return Err_longconf;
	    else {
		if (NULLFname == NULL) NULLFname = nullfbuff;
		strcpy(NULLFname, buff[j]);
	    }
	    break;
	case Ilength: 
	    if ((ret = setL(buff[j], opt)) < 0) return ret;
	    break;
	case Ispeed: 
	    if ((ret = setS(buff[j], opt)) < 0) return ret;
	    break;
	case Idecres: 
	    if ((ret = setD(buff[j], opt)) < 0) return ret;
	    break;
	case Icres: 
	    if ((ret = setC(buff[j], opt)) < 0) return ret;
	    break;
	case Iporder: 
	    if ((ret = setP(buff[j], opt)) < 0) return ret;
	    break;
	}
    }
    return No_err;
}

/* ǥեȥѥꥹȡǥեȴĶѿ̾Υå
 */
void initdefvar(int format)
{
    switch (format) {
    case E_AU:
	DEFAULTExtlist = AU_Extlist;
	DEFAULTPathlist = AU_Pathlist;
	DEFAULTConffname = AU_Conffname;
	DEFAULTExtEnvname = AU_ExtEnvname;
	DEFAULTPathEnvname = AU_PathEnvname;
	DEFAULTNULLFEnvname = AU_NULLFEnvname;
	return;
    case E_WAV:
	DEFAULTExtlist = WAV_Extlist;
	DEFAULTPathlist = WAV_Pathlist;
	DEFAULTConffname = WAV_Conffname;
	DEFAULTExtEnvname = WAV_ExtEnvname;
	DEFAULTPathEnvname = WAV_PathEnvname;
	DEFAULTNULLFEnvname = WAV_NULLFEnvname;
	return;
    case E_AIFF:
	DEFAULTExtlist = AIFF_Extlist;
	DEFAULTPathlist = AIFF_Pathlist;
	DEFAULTConffname = AIFF_Conffname;
	DEFAULTExtEnvname = AIFF_ExtEnvname;
	DEFAULTPathEnvname = AIFF_PathEnvname;
	DEFAULTNULLFEnvname = AIFF_NULLFEnvname;
	return;
    default: return;
    }
}

/* ##### -L option ؿ ##### */
/* -L Τ: ΤΤ
 * -L[bs]{n}[+-]?: b = block, s = ms, n = Ĺ[+-]?: ɲ̵
 *   (+: -: ʤ: ʤ)
 * -Ln: ̵֤ˤ
 * -Li: ֤᤹
 */
int setL(char *str, ConnOpt *opt)
{
    static int lasttype = L_undefined;
    static int lastlen = 0;
    static int lastaddsp = L_undefined;
    int k;

    if (*str == '\0') {
	(opt->total).type = lasttype;
	(opt->total).len = lastlen;
	opt->addsp = lastaddsp;
	return No_err;
    }
    else if (*str == 'b') (opt->total).type = L_block;
    else if (*str == 's') (opt->total).type = L_msec;
    else if (*str == 'n') { /* ̵֤ */
	(opt->total).type = lasttype = L_undefined;
	(opt->total).len = lastlen = 0;
	opt->addsp = lastaddsp = L_undefined;
	return No_err;
    } else if (*str == 'i') { /* ֤ */
	(opt->total).type = lasttype = defopt.total.type;
	(opt->total).len = lastlen = defopt.total.len;
	opt->addsp = lastaddsp = defopt.addsp;
	return No_err;
    } else return -Exit_invalid_arg;
    lasttype = (opt->total).type;

    if ((k = strlen(str + 1)) <= 0) return -Exit_invalid_arg;
    if (*(str + k) == '+') { 
	opt->addsp = 1; *(str + k) = '\0'; 
    } else if (*(str + k) == '-') {
	opt->addsp = -1; *(str + k) = '\0';
    } else opt->addsp = 0;
    lastaddsp = opt->addsp;

    if (((opt->total).len = atoi(str + 1)) < 0)
      return -Exit_invalid_arg;
    lastlen = (opt->total).len;
    return No_err;
}

/* ##### -s option ؿ ##### */
/* -S Τ: ΤΤ
 * -S{x}: x ͤ (times)
 * -Sn: ̵֤ˤ
 * -Si: ֤᤹
 */
int setS(char *str, ConnOpt *opt)
{
    static double lasttimes = -1.0;

    if (*str == '\0') { /* Τ */
	opt->times = lasttimes;
	return No_err;
    } else if (*str == 'n') {  /* ̵֤ */
	opt->times = lasttimes = -1.0;
	return No_err;
    } else if (*str == 'i') {  /* ֤ */
	opt->times = lasttimes = defopt.times;
	return No_err;
    }
    if ((opt->times = atof(str)) < Mintimes) return -Exit_invalid_arg;
    lasttimes = opt->times;
    return No_err;
}

/* ##### -D option ؿ ##### */
/* -D Τ: ΤΤ
 * -D[bs]{n}: b = block, s = ms, n = Ĺ
 * -Dn: ̵֤ˤ
 * -Di: ֤᤹
 */
int setD(char *str, ConnOpt *opt)
{
    static int lastttype = L_undefined;
    static int lasttlen = 0;

    if (*str == '\0') { /* Τ */
	(opt->tail).type = lastttype;
	(opt->tail).len = lasttlen;
	return No_err;
    } else if (*str == 'n') {  /* ̵֤ */
	(opt->tail).type = lastttype = L_undefined;
	(opt->tail).len = lasttlen = 0;
	return No_err;
    } else if (*str == 'i') { /* ֤ */
	(opt->tail).type = lastttype = defopt.tail.type;
	(opt->tail).len = lasttlen = defopt.tail.len;
	return No_err;
    } else if (*str == 'b') (opt->tail).type = L_block;
    else if (*str == 's') (opt->tail).type = L_msec;
    else return -Exit_invalid_arg;
    lastttype = (opt->tail).type;

    if (((opt->tail).len = atoi(str + 1)) < 0)
      return -Exit_invalid_arg;
    lasttlen = (opt->tail).len;
    return No_err;
}

/* ##### -C option ؿ ##### */
/* -C Τ: ΤΤ
 * -C[bs]{n}: b = block, s = ms, n = Ĺ
 * -Cn: ̵֤ˤ
 * -Ci: ֤᤹
 */
int setC(char *str, ConnOpt *opt)
{
    static int lasthtype = L_undefined;
    static int lasthlen = 0;

    if (*str == '\0') { /* Τ */
	(opt->head).type = lasthtype;
	(opt->head).len = lasthlen;
	return No_err;
    } else if (*str == 'n') {  /* ̵֤ */
	(opt->head).type = lasthtype = L_undefined;
	(opt->head).len = lasthlen = 0;
	return No_err;
    } else if (*str == 'i') { /* ֤ */
	(opt->head).type = lasthtype = defopt.head.type;
	(opt->head).len = lasthlen = defopt.head.len;
	return No_err;
    } else if (*str == 'b') (opt->head).type = L_block;
    else if (*str == 's') (opt->head).type = L_msec;
    else return -Exit_invalid_arg;
    lasthtype = (opt->head).type;

    if (((opt->head).len = atoi(str + 1)) < 0) 
      return -Exit_invalid_arg;
    lasthlen = (opt->head).len;
    return No_err;
}

/* ##### -P option ؿ ##### */
/* -P Τ: ΤΤ
 * -Pr[012]:  (mode)
 * -Ps{n}: ͥ (n = ͥ褹ѥֹ)
 * -Po{n}: ñȻ (n = ñȤΥѥֹ)
 * -Pn: ̵֤ˤ
 * -Pi: ֤᤹
 */
int setP(char *str, ConnOpt *opt)
{
    static int lastmode = L_undefined;
    static int lastparam = L_undefined;
    int k;
    char c;

    if ((c = *str) == '\0') {
	opt->pmode = lastmode; opt->pparam = lastparam;
	return No_err;
    }
    if ((k = atoi(str + 1)) < 0) return -Exit_invalid_arg;
    if (c == 'r') { /* random ⡼ */
	if (k == 0) { opt->pmode = 1; opt->pparam = 0; }
	else if (k== 1) { opt->pmode = 2; opt->pparam = 1; }
	else if (k== 2) { opt->pmode = 2; opt->pparam = 2; }
	else return -Exit_invalid_arg;
    } else if (c == 's') { /* swap ⡼ */
	if (k == 0) return -Exit_invalid_arg;
	opt->pmode = 3; opt->pparam = k;
    } else if (c == 'o') { /* ñȻ⡼ */
	if (k == 0) return -Exit_invalid_arg;
	opt->pmode = 4; opt->pparam = k;
    } else if (c == 'n') { /* ̵֤ */
	opt->pmode = L_undefined; opt->pparam = L_undefined;
    } else if (c == 'i') { /* ֤ */
	opt->pmode = defopt.pmode; opt->pparam = defopt.pparam;
    } else return -Exit_invalid_arg;
    lastmode = opt->pmode; lastparam = opt->pparam;
    return No_err;
}


/* HOME Ķѿ set */
int inithome(char *env[])
{
    int j;

    for (j=0; env[j]!=NULL; j++)
      if (strncmp("HOME=", env[j], 4 + 1) == 0) {
	  HOME = env[j] + 4 + 1;
	  return 1;
      }
    return 0;
}

/* '~'  $HOME Ÿ
 */
char *newfname(char *fname)
{
    static char tmp[Maxpathlen];

    if (fname == NULL) return NULL;
    if (*fname != Homechar || HOME == NULL) return fname;
    if (strlen(fname) - 1 + strlen(HOME) + 1 > Maxpathlen) /* Ĺ */
      return fname;
    strcpy(tmp, HOME);
    return strcat(tmp, fname + 1);
}

/* fopenpathlist() β
 * extlist[] Ĥƥե򸡺
 */
FILE *searchextlist(char *fname)
{
    int k, extlen, fnamelen;
    char buff[Maxpathlen];
    FILE *tmpf;
    
    if ((fnamelen = strlen(fname)) <= 0 || fnamelen > Maxpathlen) 
      return (FILE *) NULL;
    strcpy(buff, fname);
    for (k=0; k<extlistnum; k++) {
	extlen = strlen(extlist[k]);
	if (fnamelen + extlen > Maxpathlen) continue;
	buff[fnamelen] = '\0';
	strcat(buff, extlist[k]);
#ifdef DEBUG4
	fprintf(stderr, "[debug4] buff = [%s]\n", buff);
#endif
	if ((tmpf = fopen(buff, "r")) != NULL) {
	    if (listonly) printf("%s\n", buff);
	    return tmpf;
	}
    }
    return (FILE *) NULL;
}

/*  (cf. ¼֥르ꥺŵ)
 * h[0]~h[num-1] 
 */
void randomperm(int h[], int num)
{
    static int init = 0;
    int j, tmp, x;

    if (num <= 0) return;
    if (init == 0) { srand((unsigned) time(NULL)); init = 1; }
    for (j=0; j<num; j++) h[j] = j;
    for (j=num-1; j>0; j--) {
	x = (int)((j + 1)*(double) rand()/(RAND_MAX + 1.0));
	tmp = h[x]; h[x] = h[j]; h[j] = tmp;
    }
}

void initorder(void)
{
    int j;

    for (j=0; j<pathlistnum; j++) order[j] = j;
}

/* order[] 򹹿
 * mode=1: ȥ졼 ()
 * mode=2: random
 * mode=3: 1 ܤ param ܤ swap 
 * mode=4: param ܤΤ (mode=3 ƱǤ褤)
 */
int updateorder(int mode, int param)
{
    int j;

    if (mode <= 0 || mode > 4) return -1;
    if (mode == 1) for (j=0; j<pathlistnum; j++) order[j] = j;
    else if (mode == 2) randomperm(order, pathlistnum);
    else if (mode == 3) { /* mode == 3; param Ƭ */
	if (param <= 0 || param > pathlistnum) return -2;
	order[0] = param - 1;
	for (j=1; j<param; j++) order[j] = j - 1;
	for (j=param; j<pathlistnum; j++) order[j] = j;
    } else { /* mode == 4 */
	if (param <= 0 || param > pathlistnum) return -3;
	for (j=0; j<pathlistnum; j++) order[j] = j;
	if (param > 1) { order[0] = param - 1; order[param - 1] = 0; }
    }
    return 0;
}

/* mode=-1: ꤷ pathlist ľܳ
 * mode=0: ľ
 * mode=1: ȥ졼 ()
 * mode=2: random
 * mode=3: param ܤ 1 ܤ˻äƤ (param ͥ)
 * mode=4: param ܤΤ (param  1  swap Ф)
 * *pathnum: ºݤ˸Ĥäֹ¸
 */
FILE *fopenpathlist(char *fname, int mode, int param, int *pathnum)
{
    int j, pathlen, fnamelen, num;
    char buff[Maxpathlen];
    static int init = 0, checknums = 0;
    FILE *tmpf;

#ifdef DEBUG4
    fprintf(stderr, "[debug4] fopenpathlist(%s, %d, *)\n", fname, mode);
#endif
    if ((fnamelen = strlen(fname)) <= 0 || fnamelen > Maxpathlen) 
      return (FILE *)NULL;
#ifdef WITHPATHOPEN
    /* fname  path ʬĤƤޤ open Ƥߤ */
#ifdef DEBUG4
    fprintf(stderr, "[debug4] iswithpath() = %d\n", iswithpath(fname));
#endif
    if (iswithpath(fname) 
	|| (mode== -1 && pathnum != NULL && *pathnum== -1)) {
	if ((tmpf = searchextlist(fname)) != NULL) { 
	    if (pathnum != NULL) *pathnum= -1; 
	    return tmpf; 
	}
    }
#endif /* WITHPATHOPEN */
    if (init == 0) { 
	if (mode== -1) return (FILE *) NULL;
	initorder(); init = 1; 
	checknums = pathlistnum;
    }
    if (mode > 0) { /* ι */
	if (updateorder(mode, param) < 0) return (FILE *) NULL; 
	if (mode == 4) checknums = 1;
	else checknums = pathlistnum;
    } else if (mode == -1) { /* ľ */
	if (pathnum == NULL) return (FILE *) NULL;
	if (strlen(pathlist[*pathnum]) > 0) {
	    strcpy(buff, pathlist[*pathnum]);
	    mystrcat(buff, Pathdelimiter);
	} else buff[0] = '\0';
	strcat(buff, fname);
	return searchextlist(buff);
    }
#ifdef DEBUG4
    fprintf(stderr, "[debug4] checknums = %d\n", checknums);
#endif
    for (j=0; j<checknums; j++) {
	num = order[j];
	if (pathnum != NULL) *pathnum = num;
	pathlen = strlen(pathlist[num]);
#ifdef DEBUG4
	fprintf(stderr, "[debug4] [%d] pathlist[%d] = %s\n", j, 
		num, pathlist[num]);
#endif
	if (pathlen + 1 + fnamelen > Maxpathlen) continue;
	if (pathlen > 0) {
	    strcpy(buff, pathlist[num]);
	    mystrcat(buff, Pathdelimiter);
	} else buff[0] = '\0';
	strcat(buff, fname);
	if ((tmpf = searchextlist(buff)) != NULL) return tmpf;
    }
    if (verbose) fprintf(stderr, "File [%s] is not found.\n", fname);
    return (FILE *) NULL;
}

void allfree(char *array[], int curnum)
{
    int j;

    for (j=0; j<curnum; j++) free(array[j]);
}

/* ʸ liststr  Delimit ʬ䤷 list[] 
 * CurListName ä顢ϸߤΥꥹȤ֤
 * curnum = list[] θߤǿ, Maxlist = list[] , 
 * Maxlen = Ĺκ ('\0' )
 * ֤ = list[] οǿ (ʤ饨顼ȯ)
 */
int updatelist(char *list[], int curnum, int Maxlist, char *liststr, 
	       int Maxlen)
{
    int addnum = 0, curindex = 0, j, k;
    char *s, *tmp[Maxlist];

    if (liststr == NULL) return curnum;
#ifdef DEBUG4
    fprintf(stderr, "DEBUG: liststr=[%s]\n", liststr);
#endif
    if (curnum > Maxlist) { allfree(list, Maxlist); return Err_manylists; }
    /* liststr ǿ CurListName 뤫 (1 Ĥ) 򸡺 */
    s = mystrtok(liststr, Listdelimiter);
    do {
	addnum ++;
	if (Maxlen > 0 && strlen(s) >= Maxlen) return Err_longconf;
	if ((tmp[addnum - 1] = (char *)malloc(strlen(s) + 1)) == NULL) {
	    allfree(tmp, addnum - 1); 
	    allfree(list, curnum);
	    return Err_malloc;
	}
	strcpy(tmp[addnum - 1], s);
#ifdef DEBUG4
	fprintf(stderr, "DEBUG: tmp[%d]=[%s]\n", addnum, s);
#endif
	if (! strcmp(s, CurListName)) {
	    if (curindex > 0) { curindex = -1; break; }
	    curindex = addnum;
	}
    } while ((s = mystrtok(NULL, Listdelimiter)) != NULL);
#ifdef DEBUG4
    fprintf(stderr, "DEBUG: (curindex, addnum, curnum) = (%d, %d, %d)\n", 
	   curindex, addnum, curnum);
#endif
    if (curindex < 0 || addnum + curnum > Maxlist) {
	allfree(tmp, addnum);
	allfree(list, curnum);
	return Err_manylists;
    }
    /* CurListName äƬǤʤ򤽤ե */
    if (curindex > 1 && curnum > 0) 
      for (j=curnum-1; j>=0; j--) list[j + curindex - 1] = list[j];
    /* liststr ŸƶȤƤ */
    if (curindex > 0) {
	k = 0;
	for (j=0; j<=curindex-2; j++) list[j] = tmp[k ++];
	for (j=curnum+curindex-1; j<=curnum+addnum-2; j++) 
	  list[j] = tmp[++ k];
#ifdef DEBUG4
	for (j=0; j<=curnum+addnum-2; j++) 
	  fprintf(stderr, "DEBUG: list[%d]=[%s]\n", j, list[j]);
#endif
	return curnum + addnum - 1;
    } else {
	for (j=0; j<addnum; j++) list[j] = tmp[j];
	return addnum;
    }
}



/* ########## string ########## */
/* 1) strtok()  constant ʸؤϻȤʤ
 * 2) ":a::b"  "a", "b" ֤ʤ
 */
char *mystrtok(char *str, char c)
{
    static char tmp[Maxbuff];
    static char *s0, *s1, *s2;
    
    /* if(strlen(str)>=Maxbuff) return NULL; 
     * Ƚ̤ϳǤ뤳Ȥˤ
     */
    if (str != NULL) {
	strcpy(tmp, str);
	s0 = tmp;
	s2 = tmp + strlen(tmp);
    } else {
	if (s1 >= s2) return NULL;
	s0 = s1 + 1;
    }
    s1 = s0;
    while (*s1 != c) if (++s1 >= s2) break;
    if (s1 >= s2) return s0;
    *s1 = '\0';
    return s0;
}

char *mystrcat(char *str, char c)
{
    int len = strlen(str);

    *(str + len) = c;
    *(str + len + 1) = '\0';
    return str;
}

int iswithpath(char *filename)
{
    if (strchr(filename, Pathdelimiter) != NULL) return 1;
    else return 0;
}

/* ##### DEBUG ##### */
#ifdef DEBUG4
void putallpathlist(void)
{
    int j;

    for (j=0; j<pathlistnum; j++)
      fprintf(stderr, "[debug4] pathlist[%d] = [%s]\n", j, pathlist[j]);
}

void putallextlist(void)
{
    int j;

    for (j=0; j<extlistnum; j++)
      fprintf(stderr, "[debug4] extlist[%d] = [%s]\n", j, extlist[j]);
}

void putallopt(ConnOpt *opt, int filenum)
{
    int j;

    for (j=0; j<filenum; j++) {
	fprintf(stderr, "[debug4] opt[%d].(pmode, pparam, fnamepos)",
		j);
	fprintf(stderr,	" = (%d, %d, %d)\n", opt[j].pmode,
		opt[j].pparam, opt[j].fnamepos);
	fprintf(stderr,	"[debug4] opt[%d].(total, head, tail)", j);
	fprintf(stderr,	" = ((%d, %ld), (%d, %ld), (%d, %ld))\n", 
		opt[j].total.type, opt[j].total.len,
		opt[j].head.type, opt[j].head.len,
		opt[j].tail.type, opt[j].tail.len);
	fprintf(stderr,	"[debug4] opt[%d].(addsp, times) = (%d, %f)\n",
		j, opt[j].addsp, opt[j].times);
    }
    fprintf(stderr, "[debug4] NULLFname = [%s]\n", 
	    NULLFname == NULL ? "(null)" : NULLFname);
}

#endif

#endif /* __CONF_C__ */
