/* ץ󥭥ѥ¸ Tcl/Tk ץ mksnd1 ѥץ
 * shige
 * 01/05 2005 
 * mknsd1.c
 * 
 * $Id: mksnd1.c,v 1.4 2017-03-07 17:38:24+09 shige Exp $
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "common.h"

/*####### prototype #######*/
int main(int argc, char *argv[]);
int str2Array(char *s);
int str2Array2(char *s);
double f0(double x, int n);
double f1(double x, int m);
int putdat(FILE *ofile, double sec, double freq, int n, int m);
int putsound(FILE *ofile, int mode, double sec, double freq, int n,
	     int m);
void usage(char *commname);

/*#######  #######*/
#define Maxarray 500
#define Ymax 100.0

#define Minfreq 80.0
#define Maxfreq 1000.0
#define Minseq 0.0
#define Maxseq 20.0
#define Sampling 8000

/*####### ѿ #######*/
double yarr[Maxarray + 1], Tarr[Maxarray + 1]; 
double zarr[Maxarray + 1], Sarr[Maxarray + 1]; 
/*
 * yarr, Tarr: ȷ
 * zarr, Sarr: 
 *
 * yarr[0]~yarr[n-1],yarr[n]: y1~yn,y1 
 * zarr[0]~zarr[m]: z0~zm
 * Tarr[j]=d1+...+dj (j=1~n), Tarr[0]=0
 * Sarr[j]=h1+...+hj (j=1~m), Sarr[0]=0
 * yarr ͤ (100.0 ǳä -1.0~1.0 ) 롣
 */

int main(int argc, char *argv[])
{
    double Sec, Freq;
    int n, m, mode;

    if (argc != 5 + 1) { usage(argv[0]); return 1; }
    if ((Sec = atof(argv[1])) <= Minseq || Sec >= Maxseq 
       || (Freq = atof(argv[2])) <= Minfreq || Freq >= Maxfreq) {
	usage(argv[0]); 
	return 2; 
    }
    if ((n = str2Array(argv[3])) <= 0) { usage(argv[0]); return 3; }
    if ((m = str2Array2(argv[4])) <= 0) { usage(argv[0]); return 4; }
    if ((mode = atoi(argv[5])) < 0) { usage(argv[0]); return 5; }

    if (mode == 0) putdat(stdout, Sec, Freq, n, m); 
    else if (mode >= 1 && mode <= 8) 
      putsound(stdout, mode, Sec, Freq, n, m);
    else { usage(argv[0]); return 6; }
    return 0;
}

/* y1 : d1 : ... : yn : dn  */
int str2Array(char *s)
{
    char *s1;
    int n = 0, j;

    if (strlen(s) <= 0) return 0;
    if ((s1 = strtok(s, ":")) == NULL) return 0;
    Tarr[0] = 0.0;
    while (s1 != NULL) {
	if (++ n > Maxarray) return -1;
	if (strlen(s1) <= 0) return -5;
	if ((j = atoi(s1)) > Ymax || j < -Ymax) return -2;
	yarr[n - 1] = j/Ymax;
	if ((s1 = strtok(NULL, ":")) == NULL) return -3;
	if (strlen(s1) <= 0) return -5;
	if ((j = atoi(s1)) <= 0) return -4;
	Tarr[n] = Tarr[n - 1] + j;
	s1 = strtok(NULL, ":");
    }
    yarr[n] = yarr[0];
    return n;
}

/* z0 : h1 : ... : hn : zn  */
int str2Array2(char *s)
{
    char *s1;
    int m = 0, j;

    if (strlen(s) <= 0) return 0;
    if ((s1 = strtok(s, ":")) == NULL || strlen(s1) <= 0) return -1;
    Sarr[0] = 0.0;
    if ((j = atoi(s1)) > Ymax || j < 0) return -2;
    zarr[0] = j/Ymax;
    if ((s1 = strtok(NULL, ":")) == NULL) return -3;
    while (s1 != NULL) {
	if (++ m > Maxarray) return -5;
	if (strlen(s1) <= 0 || (j = atoi(s1)) <= 0) return -6;
	Sarr[m] = Sarr[m - 1] + j;
	if ((s1 = strtok(NULL, ":")) == NULL || strlen(s1) <= 0)
	  return -7;
	if ((j = atoi(s1)) > Ymax || j < -Ymax) return -8;
	zarr[m] = j/Ymax;
	s1 = strtok(NULL, ":");
    }
    return m;
}

double f0(double x, int n)
{
    double T = Tarr[n], r;
    int j;

    x -= floor(x/T)*T;
    /*
     * if(x<0.0) x+=T; else if(x>T) x-=T;
     * if(x<0.0) x=0.0; else if(x>T) x=T;
     */
    for (j=1; j<n; j++) if (Tarr[j] >= x) break;
    r = (yarr[j] - yarr[j - 1])/(Tarr[j] - Tarr[j - 1]);
    return yarr[j - 1] + (x - Tarr[j - 1])*r;
}

/* Ϥ f0(F*T*t) ȤƻȤɤ */

double f1(double x, int m)
{
    double S = Sarr[m], r;
    int j;

    if (x < 0.0 || x > S) return 0.0;
    for (j=1; j<m; j++) if (Sarr[j] >= x) break;
    r = (zarr[j] - zarr[j - 1])/(Sarr[j] - Sarr[j - 1]);
    return zarr[j - 1] + (x - Sarr[j - 1])*r;
}

/* Ϥ f1(S*t/sec) ȤƻȤɤ */

/* .dat νϴؿ 
 */
int putdat(FILE *ofile, double sec, double freq, int n, int m)
{
    int j, last = sec*Sampling;
    double T = Tarr[n], x = 1.0/Sampling, conv = Sarr[m]/sec;

    fprintf(ofile, "; Sample Rate %d\n", Sampling);
    for (j=0; j<=last; j++)
      fprintf(ofile, "%f %f\n", x*j, 
	      f0(freq*T*x*j, n)*f1(conv*x*j, m));
    return 0;
}

int putsound(FILE *ofile, int mode, double sec, double freq, int n,
	     int m)
{
    int form, header, bit, j, bs;
    long int last = sec*Sampling;
    SNDheader snd;
    double x, c1 = Tarr[n]*freq/Sampling, c2 = Sarr[m]/(sec*Sampling);

    switch (mode) {
    case 1: form = E_AU; header = 0; bit = 8; break;
    case 2: form = E_AU; header = 1; bit = 8; break;
    case 3: form = E_WAV; header = 0; bit = 8; break;
    case 4: form = E_WAV; header = 1; bit = 8; break;
    case 5: form = E_WAV; header = 0; bit = 16; break;
    case 6: form = E_WAV; header = 1; bit = 16; break;
    case 7: form = E_AIFF; header = 0; bit = 16; break;
    case 8: form = E_AIFF; header = 1; bit = 16; break;
    default: return -1;
    }
    setSNDheader(&snd, form, 0, 1, Sampling, bit, last + 1,
		 CH_MAGIC | CH_CHANNEL | CH_BITPERSMPL | CH_SMPLRATE
		 | CH_BLOCKS);
    bs = SNDblocksize(&snd, form);
    if (header) { if (putSNDheader(ofile, &snd, form) < 0) return 3; }

    for (j=0; j<=last; j++) {
	x = f0(c1*j, n)*f1(c2*j, m);
	SNDput1chleveldata(ofile, x, &snd, form);
    }
    if (header && form != E_AU && bs%2 && (last + 1)%2)
      fputc(0, ofile);
    return 0;
}

void usage(char *commname)
{
    fprintf(stderr, "Usage: %s", commname);
    fprintf(stderr, " [ÿ] [ȿ] [ȷ] [] [Ϸ]\n");
    fprintf(stderr, "1) %f < [ȿ] < %f\n", Minfreq, Maxfreq);
    fprintf(stderr, "2) ȷ\n");
    fprintf(stderr, "     y1:d1:y2:d2:...:yn:dn\n");
    fprintf(stderr, "   η (y1~yn: -100~100 ,");
    fprintf(stderr, " d1~dn: )\n");
    fprintf(stderr, "   yj ϴȷι⤵dj  y(j+1) ");
    fprintf(stderr, " yj δֳ֤λꡣ\n");
    fprintf(stderr, "   줬ȿˤäƷ֤롣\n");
    fprintf(stderr, "3) ȷ\n");
    fprintf(stderr, "     z0:h1:z1:h2:z2:...:hk:zk\n");
    fprintf(stderr, "   η (z0~zk: 0~100 ,");
    fprintf(stderr, " h1~hk: )\n");
    fprintf(stderr, "   zj ȷι⤵hj  z(j+1) ");
    fprintf(stderr, " zj δֳ֤λꡣ\n");
    fprintf(stderr, "4) Ϸ (Υ):\n");
    fprintf(stderr, "   0: sox dat \n");
    fprintf(stderr, "   1:  8bit -law (%dHz), AU raw data\n", 
	    Sampling);
    fprintf(stderr, "   2:  8bit -law (%dHz), AU (header )\n", 
	    Sampling);
    fprintf(stderr, "   3:  8bit linear (%dHz), WAV raw data\n", 
	    Sampling);
    fprintf(stderr, "   4:  8bit linear (%dHz), WAV (header )\n",
	    Sampling);
    fprintf(stderr, "   5: 16bit linear (%dHz), WAV raw data\n",
	    Sampling);
    fprintf(stderr, "   6: 16bit linear (%dHz), AIFF (header )\n",
	    Sampling);
    fprintf(stderr, "   7: 16bit linear (%dHz), WAV raw data\n",
	    Sampling);
    fprintf(stderr, "   8: 16bit linear (%dHz), AIFF (header )\n",
	    Sampling);
    fprintf(stderr, "   (åϥץ󥰼ȿ)\n");
}
