/* ǡ monoral data Ф
 * 12/30 2003
 * shige
 * sndchan.c
 *
 * $Id: sndchan.c,v 1.10 2017-03-28 21:04:02+09 shige Exp $
 */
/* sndchan (-o [file]) -c[n] [file0]
 *  -c[n]: 
 *  -c1: left data  stdout (or [file])
 *  -c2: right data  stdout (or [file])
 *
 * 1)	n=0 ʤ顢줾 file ̾ file 뤳ȤˤƤ⤤
 * 2)	sox Ǥ
 * 	     sox file.wav -c 1 hoge.wav pick -l (-r)
 *	ǤǤ롣
 * 3)	psselect ˻ channel γĥԤʤ
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "common.h"

#define Maxchan MAXChannel

int main(int argc, char *argv[]);
int get1blockrawdata(FILE *infile, SNDheader *snd, int format, 
                  unsigned int rawdata[]);
void put1chrawdata(FILE *outfile, SNDheader *snd, int format,
                   unsigned int n);
int cstr2array(char *s0, int ich, int charray[]);
int setarray(int mode, char *s, int ich, int charray[]);
int getarg(int argc, char **argv, int *Mode, char **Chstr, FILE **infile,
           FILE **outfile);
void usage(int ret);

int main(int argc, char *argv[])
{
    FILE *infile, *outfile;
    SNDheader isnd, osnd;
    int charray[Maxchan], ich, och, format, bs, k, ret, mode;
    long int j, blocks;
    char *chstr;
    unsigned int rawdata[Maxchan];
    
    ret = getarg(argc, argv, &mode, &chstr, &infile, &outfile);
    if (ret <= 0) { usage(ret); return -ret; }
    if ((format = getSNDheader(infile, &isnd)) < 0 
	|| format == E_UNKNOWN) {
	fprintf(stderr, "Error in getSNDheader(). (%d)\n", format);
	return 20;
    }
    if ((ich = SNDchannels(&isnd, format)) > Maxchan) {
	fprintf(stderr, "Error: too many channels in data. (%d)\n", 
		ich);
	return 30;
    }
    if ((och = setarray(mode, chstr, ich, charray)) <= 0) {
	fprintf(stderr, "Error in setarray(). (%d)\n", och);
	return 40;
    }
#ifdef DEBUG1
    fprintf(stderr, "DEBUG: (mode,ich,och) = (%d, %d, %d)\n",
	    mode, ich, och);
    fprintf(stderr, " charray[] = ");
    for (k=0; k<och; k++)
      fprintf(stderr, "%s%d", k ? ", " : "(", charray[k]);
    fprintf(stderr, ")\n");
#endif
    blocks = SNDblocks(&isnd, format);
    cpSNDheader(&osnd, &isnd, format);
    setSNDheader(&osnd, format, 0, och, 0, 0, blocks, 
		 CH_CHANNEL | CH_BLOCKS);
    putSNDheader(outfile, &osnd, format);
    for (j=1L; j<=blocks; j++) {
	if (get1blockrawdata(infile, &isnd, format, rawdata) < 0) {
	    fprintf(stderr, "Error: get1blockrawdata(). (%ld)\n", j);
	    return 50;
	}
#ifdef DEBUG1
	if (j <= 3L) {
	    fprintf(stderr, "DEBUG: rawdata[] = ");
	    for (k=0; k<ich; k++) 
	      fprintf(stderr, "%s%04x", k ? ", " : "(", rawdata[k]);
	    fprintf(stderr, ")\n");
	}
#endif
	for (k=0; k<och; k++) 
	  put1chrawdata(outfile, &osnd, format, rawdata[charray[k]]);
    }
    bs = SNDblocksize(&osnd, format);
    if (format != E_AU && bs%2 && blocks%2) fputc(0, outfile);
    return 0;
}

/* #####  raw data ¸ؿϴؿ ##### */
int get1blockrawdata(FILE *infile, SNDheader *snd, int format, 
		  unsigned int rawdata[])
{
    int ch = SNDchannels(snd, format);
    int bps = SNDbitpersmpl(snd, format);
    int k, m, c;

    for (k=0; k<ch; k++) {
	rawdata[k] = 0;
	for (m=0; m<bps/8; m++) {
	    if ((c = fgetc(infile)) == EOF) return -1;
	    rawdata[k] = (rawdata[k] << 8) | (0x00ff & c);
	}
    }
    return 0;
}

void put1chrawdata(FILE *outfile, SNDheader *snd, int format,
		   unsigned int n)
{
    int bps = SNDbitpersmpl(snd, format);
    int m;

    for (m=bps/8-1; m>=0; m--) 
      fputc((n >> (m*8)) & 0x00ff, outfile);
}

/* ##### ץ ##### */
/* -c ץʸ *s0 Ϥ charray[] ˥å
 * ich = ϥͥ
 * return value = ϥͥ (0 ʲʤ饨顼)
 */
int cstr2array(char *s0, int ich, int charray[])
{
    int oind = 0, nind = 0, num[2], k, dn;
    char *s = s0;

    if (ich <= 0 || ich > Maxchan) return -1;
    num[0] = 0;
    while (1) {
	if (*s == ',' || *s == '\0') { 
	    /* θߤξ֤˥å */
	    if (num[nind] <= 0 || num[nind] > Maxchan 
		|| num[nind] > ich)
	      return -2; 
	    if (nind == 0 || num[0] == num[1]) { /* - ʤ */
		if (++ oind > Maxchan) return -3;
		charray[oind - 1] = num[nind] - 1;
	    } else { /* a-b */
		if (num[0] < num[1]) dn = 1; else dn = -1;
		k = num[0];
		while (1) {
		    if (++ oind > Maxchan) return -4;
		    charray[oind - 1] = k - 1;
		    k += dn;
		    if (dn > 0 && k > num[1]) break;
		    if (dn < 0 && k < num[1]) break;
		}
	    }
	    if (*s == '\0') break;
	    nind = 0; num[0] = 0;
	} else if (*s == '-') {
	    if (num[nind] <= 0 || num[nind] > Maxchan 
		|| num[nind] > ich) 
	      return -5; 
	    num[++ nind] = 0;
	} else if (*s == 'L') {
	    num[nind] = ich;
	} else if (*s >= '0' || *s <= '9') {
	    if (num[nind] == 0 && *s == '0') return -6;
	    num[nind] = num[nind]*10 + *s - '0';
	} else return -7;
	s ++;
    }
    return oind;
}

/* charray[k-1] = ϥǡ $k$ ܤ˻ѤϤ ch ֹ - 1
 * return value = ϥͥ (0 ʲʤ饨顼)
 */
int setarray(int mode, char *s, int ich, int charray[])
{
    int k, m;

#ifdef DEBUG1
    fprintf(stderr, "DEBUG: setarray(): (mode, s, ich) = (%d, %s, %d)\n",
	    mode, s, ich);
#endif
    if (ich <= 0 || ich > Maxchan) return -11;
    if (mode == 1) { /* -r */
	for (k=1; k<=ich; k++) charray[k - 1] = ich - k;
	return ich;
    } else if (mode == 2) { /* -g */
	if (ich <= 1) return -12;
	for (k=1, m=2; m<=ich; k++, m+=2) charray[k - 1] = m - 1;
	return k - 1;
    } else if (mode == 3) { /* -k */
	for (k=1, m=1; m<=ich; k++, m+=2) charray[k - 1] = m - 1;
	return k - 1;
    } else if (mode == 0) { /* -c */
	return cstr2array(s, ich, charray);
    } else return -13;
}


/* Mode == 0: -c== 1: -r, == 2: -g, == 3: -k */
int getarg(int argc, char **argv, int *Mode, char **Chstr, FILE **infile,
	   FILE **outfile)
{
    *outfile = stdout;
    *infile = stdin;
    *Chstr = NULL;
    *Mode = 0;

    while (-- argc > 0) {
	if (**(++ argv) == '-') {
	    switch (*(++ *argv)) {
	    case 'c': 
		if (*(++ *argv) == '\0') { 
		    if (-- argc <= 0) return -1;
		    else argv ++;
		}
		*Chstr = *argv;
		*Mode = 0;
		break;
	    case 'r': *Mode = 1; *Chstr = NULL; break;
	    case 'g': *Mode = 2; *Chstr = NULL; break;
	    case 'k': *Mode = 3; *Chstr = NULL; break;
	    case 'h':
	    case 'H':
	    case '?': return 0;
	    case 'o':
		if (*outfile != stdout) return -3;
		if (*(++ *argv) == '\0') { 
		    if (-- argc <= 0) return -4;
		    else argv++;
		}
		if (! strcmp(*argv, "-")) *outfile = stdout;
		else if ((*outfile = fopen(*argv, "w")) == NULL) {
		    fprintf(stderr, "File [%s] open error.\n", *argv);
		    return -5;
		}
		break;
	    case '\0': break;
	    default: return -6;
	    }
	    if (**argv == '\0') { -- *argv; break; }
	} else break;
    }
    if (argc > 1) {
#ifdef DEBUG1
	fprintf(stderr, "DEBUG1: %d\n", argc);
#endif
	return -7;
    }
    if (argc < 1) return 1;
    if (! strcmp(*argv, "-")) *infile = stdin;
    else if ((*infile = fopen(*argv, "r")) == NULL) {
	fprintf(stderr, "File [%s] open error.\n", *argv);
	return -9;
    }
    return 1;
}

void usage(int ret)
{
    char *mess[] = {
	"Usage: sndchan (-o[outfile]) (-c[s]|-r|-g|-k) ([infile])",
	"   -o[outfile] : ϥեλ (default: ɸ)",
	"   -c[s] : Ūʥͥ",
	"   -r: ս",
	"   -g: ͥΤߤФ",
	"   -k: ͥΤߤФ",
	"   [infile] : ϥե (ά: ɸ)",
	" ",
	" [1] ϥե '-' ꤷɸϤˤʤ롣",
	" [2] ͥ -c, -r, -g, -k ¾ŪǡǸ˻",
	"   ΤΤߤͭˤʤ롣",
	" [3] -c[s]  [s] ˤϡֹͥ ',', '-', 'L' ʸ",
	"   Ȥ߹碌ͥؼʸꤷꤵ줿",
	"   ͥǡ֤¤٤줿ǡϤ롣",
	"   ',' '-' Ϣ³ϰϡǡ 'L' Ϻǽ",
	"   ̣ͥ (ǽΥͥ 1 ȿ):",
	"     -c2,4 : 2ch  4ch 󤷤 2 ͥǡ",
	"     -c2-4 : 2ch, 3ch, 4ch  (3 ͥǡ)",
	"     -c4-2 : 4ch, 3ch, 2ch ",
	"     -c1,L-2: 2ch ʹߤս",
#if 0
	" [4]  -c-3 (= -c1-3)  -c2- (= -c2-L) 򥵥ݡȤ",
	"   ߤϤνǧʤ",
#endif
	NULL
    };
    int j;

#ifdef DEBUG1
    printf("USAGE: %d\n", ret);
#endif
    for (j=0; mess[j]!=NULL; j++) fprintf(stderr, "%s\n", mess[j]);
}
