/* ǡκʬĴ٤
 * 03/23 2017
 * shige
 * snddiff.c
 *
 * $Id: snddiff.c,v 1.7 2017-03-29 14:49:11+09 shige Exp $
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "common.h"

#define Maxfiles 20

int main(int argc, char *argv[]);
int diff1block1ch(FILE *files[], SNDheader snd[], int format, 
                  int filenum, long int blockn, int chn, int gbit, 
                  double glevel, int verbose);
int chheaders(char *fnames[], FILE *files[], SNDheader snd[], 
              int *Format, int filenum, int verbose);
int mychSNDheader(SNDheader *snd1, SNDheader *snd2, int format);
int SNDget1chrawdata(FILE *infile, SNDheader *snd, int format, 
		     short int *Sx);
int getarg(int argc, char **argv, char *fnames[], int *Channel,
           int *Bits, int *Verbose, double *Level);
void usage(int ret);

int main(int argc, char *argv[])
{
    SNDheader snd[Maxfiles];
    FILE *files[Maxfiles];
    int ret, format, ch, gch, gbit, verbose, filenum, m;
    double glevel;
    long int j, blocks, diffs;
    char *fnames[Maxfiles];
    
    ret = getarg(argc, argv, fnames, &gch, &gbit, &verbose, &glevel);
    if (ret < 0) { usage(ret); return -ret + 10; }
    else filenum = ret;
#if DEBUG0
    for (k=0; k<filenum; k++)
      fprintf(stderr, "DEBUG: fnames[%d] = %s\n", k, fnames[k]);
    fprintf(stderr, "DEBUG: (gch, gbit, verbose, glevel)");
    fprintf(stderr, " = (%d, %d, %d, %f)\n", gch, gbit, verbose, glevel);
    return 0;
#endif
    ret = chheaders(fnames, files, snd, &format, filenum, 
		       verbose);
    if (ret < 0) return -ret + 20;

    /* 餤褤ӡ*/
    blocks = SNDblocks(&snd[0], format);
    ch = SNDchannels(&snd[0], format);
    /* glevel < 0 && gbit < 0 ==> level  */
    /* glevel >= 0 ==> level  */
    /* gbit >= 0 ==> bit  */
    if (gbit < 0) glevel = 0.0;
    if ((gch > 0 && gch > ch) || (gch < 0 && -gch > ch)) return 30;
    diffs = 0L;
    for (j=1L; j<=blocks; j++) 
      for (m=1; m<=ch; m++) {
	  if (gch > 0 && gch != ch) continue;
	  if (gch < 0 && gch == ch) continue;
	  ret = diff1block1ch(files, snd, format, filenum, j, m, gbit,
			      glevel, verbose);
	  if (ret < 0) return -ret + 30;
	  else diffs += ret;
#ifdef DEBUG1
	  if (ret > 0) fprintf(stderr, "%ld/%d: %d\n", j, m, ret);
#endif
      }
    /* diffs ɬפʤ */
    if (verbose > 0) 
      fprintf(stderr, "Total: %ld diffs are found.\n", diffs);
    if (diffs > 0) return 1; else return 0;
}

int diff1block1ch(FILE *files[], SNDheader snd[], int format, 
		  int filenum, long int blockn, int chn, int gbit, 
		  double glevel, int verbose)
{
    int k, m, ret, diffs = 0;
    double datax[Maxfiles], x;
    short int datan[Maxfiles], n;

    for (k=0; k<filenum; k++)
      if (gbit < 0) /* level  */
	datax[k] = SNDget1chleveldata(files[k], &snd[k], format);
      else {
	  ret = SNDget1chrawdata(files[k], &snd[k], format, 
				 &datan[k]);
	  if (ret < 0) {
	      if (verbose > 0) 
		fprintf(stderr, "SNDget1chrawdata() error (%d)\n", k);
	      return -31;
	    }
      }
    for (k=0; k<filenum-1; k++)
      for (m=k+1; m<filenum; m++)
	if (gbit < 0) {
	    x = datax[k] - datax[m];
	    if (Abs(x) > glevel) {
		if (verbose >= 2)
		  fprintf(stderr, "%ld/%d: [%d]-[%d] = %f\n", blockn, 
			  chn, k, m, x);
		diffs ++;
	    }
	} else {
	    n = datan[k] - datan[m];
	    if (Abs(n) > gbit) {
		if (verbose >= 2)
		  fprintf(stderr, "%ld/%d: [%d]-[%d] = %d\n", blockn,
			  chn, k, m, n);
		diffs ++;
	    }
	}
    return diffs;
}

int chheaders(char *fnames[], FILE *files[], SNDheader snd[], 
	      int *Format, int filenum, int verbose)
{
    int m = 0, k, form;

    if (filenum < 2 || filenum > Maxfiles) return -1;
    for (k=0; k<filenum; k++) {
	if (! strcmp(fnames[k], "-")) { 
	    if (++ m > 1) {
		if (verbose > 0)
		  fprintf(stderr, 
			  "Do not specify stdin (-) twice.\n");
		return -2;
	    } else files[k] = stdin;
	}
	else if ((files[k] = fopen(fnames[k], "r")) == NULL) {
	    if (verbose > 0)
	      fprintf(stderr, "Cannot open file %s\n", fnames[k]);
	    return -3;
	}
    }
    if ((*Format = getSNDheader(files[0], &snd[0])) < 0) {
	if (verbose > 0)
	  fprintf(stderr, "getSNDheader() error. (%s)\n", fnames[0]);
	return -4;
    }
    for (k=1; k<filenum; k++) {
	if ((form = getSNDheader(files[k], &snd[k])) < 0) {
	    if (verbose > 0)
	      fprintf(stderr, "getSNDheader() error. (%s)\n", 
		      fnames[k]);
	    return -4;
	}
	if (form != *Format 
	    || mychSNDheader(&snd[0], &snd[k], *Format) != 0) {
	    if (verbose > 0)
	      fprintf(stderr, "SNDheader of %s is not equal to %s.\n",
		      fnames[k], fnames[0]);
	    return -5;
	}
    }
    return 0;
}	

/* : 顼0: : ʤ */
int mychSNDheader(SNDheader *snd1, SNDheader *snd2, int format)
{
    long int blocks;

    if (snd1 == NULL || snd2 == NULL) return -1;
    if (SNDchheaderMASK(snd1, snd2, format, CH_ALL) < 0) return 1;
    blocks = SNDblocks(snd1, format);
    if (SNDblocks(snd2, format) != blocks) return 2;
    return 0;
}

int SNDget1chrawdata(FILE *infile, SNDheader *snd, int format, 
		     short int *Sx)
{
    int c;

    switch(format) {
    case E_AU: 
	if ((c = fgetc(infile)) == EOF) return Err_fread;
	else { *Sx = c; return No_err; }
    case E_WAV: 
	if ((snd->wav).bitpersmpl == 8) {
	    if ((c = fgetc(infile)) == EOF) return Err_fread;
	    else { *Sx = c; return No_err; }
	} else {
	    if (read2bytetolittlei(infile, Sx) < 0) return Err_fread;
	    else return No_err;
	}
    case E_AIFF:
	if ((snd->aiff).bitpersmpl == 8) {
	    if ((c = fgetc(infile)) == EOF) return Err_fread;
	    else { *Sx = c; return No_err; }
	} else {
	    if (read2bytetoi(infile, Sx) < 0) return Err_fread;
	    else return No_err;
	}
    default: return Err_param;
    }
}

/* -b ΤȤ SNDget1chrawdata() ӡ
 * -l ΤȤ SNDget1chleveldata() ӡ
 */
int getarg(int argc, char **argv, char *fnames[], int *Channel,
	   int *Bits, int *Verbose, double *Level)
{
    int j;

    *Bits = -1;
    *Level = -1.0;
    *Verbose = 0;
    *Channel = 0;
    fnames[0] = NULL;

    while (-- argc > 0) {
	if (**(++ argv) == '-') {
	    switch (*(++ *argv)) {
	    case 'v': 
		if (*(++ *argv) == '\0') { 
		    if (-- argc <= 0) return -1; 
		    else argv ++; 
		}
		if ((*Verbose = atoi(*argv)) < 0) return -2;
		break;
	    case 'c':
		if (*(++ *argv) == '\0') { 
		    if (-- argc <= 0) return -1; 
		    else argv ++; 
		}
		*Channel = atoi(*argv);
		break;
	    case 'b':
		if (*(++ *argv) == '\0') { 
		    if (-- argc <= 0) return -1; 
		    else argv ++; 
		}
		if ((*Bits = atoi(*argv)) < 0) return -4;
		else *Level = -1.0;
		break;
	    case 'l':
		if (*(++ *argv) == '\0') { 
		    if (-- argc <= 0) return -1; 
		    else argv ++; 
		}
		if ((*Level = atof(*argv)) < 0.0) return -5;
		else *Bits = -1;
		break;
	    case 'h':
	    case 'H':
	    case '?': return 0;
	    case '\0': break;
	    default: return -3;
	    }
	    if (**argv == '\0') { --*argv; break; }
	} else break;
    }
    if (argc < 2 || argc > Maxfiles) return -4;
    -- argv;
    for (j=0; j<argc; j++) fnames[j] = *(++ argv);
    return argc;
}

void usage(int ret)
{
    char *mess[] = {
	"Usage: snddiff [option] [file1] [file2] ([file3] ...)",
	" [option]:",
	"   -v[n]: ٥ [n] (0, 1, 2, default: 0)",
	"   -l[x]: [x] (¿) ʲΥ٥ͤκ̵",
	"   -b[n]: [n] () ʲ̻ҥӥåͤκ̵",
	"   -c[n]: channel ",
	" ",
	" [1] ꤷե˰㤤뤫ݡȤ롣",
	" [2] ե̾ '-' ꤷɸ (Ĥޤ)",
	"   3 İʾꤷϡΤ 2  (n(n-1)/2 ̤) "
	"   㤤򤹤٤Ĵ٤롣",
	" [3] -v ٥ [n] ϡ0: Ϥʤ1: Τ߽ϡ",
	"   2: ٤Ƥΰ㤤ϡȤʤ롣0 ξϡλ status ",
	"   ǰ㤤ΤʤȽǤǤ (0 => ʤ1 => ꡢ2 ",
	"   ʤХ顼λ)",
	" [4] -b ξϥӥåȸԤ̻ҥӥåȥ",
	"   ߤ 8bit, 16bit ΤߥݡȤ롣",
	NULL
    };
    int j;

    for (j=0; mess[j]!=NULL; j++) fprintf(stderr, "%s\n", mess[j]);
}
