/* 
 * format (ñ) Ѵ
 * shige
 * 01/12 2004
 * 
 * $Id: sndform.c,v 1.6 2017-03-09 19:19:06+09 shige Exp $
 */
#include <stdio.h>
#include <stdlib.h>
#include "common.h"

int main(int argc, char *argv[]);
int cpSNDheaderTrans(SNDheader *osnd, SNDheader *isnd, int oformat,
		     int iformat);
int putSNDheaderTrans(FILE *outfile, SNDheader *snd, int iformat,
		       int oformat);
int SNDreadput1chdataTrans(FILE *infile, FILE *outfile, SNDheader *snd,
                           int iformat, int oformat);
int getarg(int argc, char **argv, int *Oformat, FILE **infile,
	   FILE **outfile);
void usage(int ret);

int main(int argc, char *argv[])
{
    FILE *infile, *outfile;
    SNDheader snd;
    int iformat, oformat, ch, bs;
    long int blocks;
    int j, k, ret;

    if ((ret = getarg(argc, argv, &oformat, &infile, &outfile)) <= 0) {
	usage(ret); return -ret;
    }
    if ((iformat = getSNDheader(infile, &snd)) < 0
	|| iformat == E_UNKNOWN) {
        fprintf(stderr, "get header error.\n");
        return 3;
    }
    putSNDheaderTrans(outfile, &snd, iformat, oformat);    
    ch = SNDchannels(&snd, iformat);
    blocks = SNDblocks(&snd, iformat);
    bs = SNDblocksize(&snd, iformat);
    for (j=1; j<=blocks; j++)
      for (k=1; k<=ch; k++) 
	SNDreadput1chdataTrans(infile, outfile, &snd, iformat, oformat);
    if (oformat != E_AU && bs%2 && blocks%2) fputc(0, outfile);
    return 0;
}

/* ʲ 3 Ĥ common.c Ԥ */
/* ==> getSNDheader() ơƼǡơsetSNDheader() Ф
 */
int cpSNDheaderTrans(SNDheader *osnd, SNDheader *isnd, int oformat,
		     int iformat)
{
    int flags;

    if ((iformat != E_AU && iformat != E_WAV && iformat != E_AIFF)
       || (oformat != E_AU && oformat != E_WAV && oformat != E_AIFF))
      return -1;
    else if (iformat == oformat) {
	cpSNDheader(osnd, isnd, iformat);
	return 1;
    }
    flags = CH_MAGIC | CH_FMCODE | CH_CHANNEL | CH_SMPLRATE 
	| CH_BITPERSMPL | CH_BLOCKS;
    return setSNDheader(osnd, oformat, 1, SNDchannels(isnd, iformat),
			SNDsmplrate(isnd, iformat),
			SNDbitpersmpl(isnd, iformat),
			SNDblocks(isnd, iformat),
			flags);
}

int putSNDheaderTrans(FILE *outfile, SNDheader *snd, int iformat,
		      int oformat)
{
    SNDheader osnd;
    if ((iformat != E_AU && iformat != E_WAV && iformat != E_AIFF)
       || (oformat != E_AU && oformat != E_WAV && oformat != E_AIFF))
      return -1;
    else if (iformat == oformat) {
	putSNDheader(outfile, snd, iformat); 
	return 1;
    } else {
	cpSNDheaderTrans(&osnd, snd, oformat, iformat);
	putSNDheader(outfile, &osnd, oformat);
	return 0;
    }
}

int SNDreadput1chdataTrans(FILE *infile, FILE *outfile, SNDheader *snd,
			   int iformat, int oformat)
{
    SNDheader osnd;
    double x;

    if ((iformat != E_AU && iformat != E_WAV && iformat != E_AIFF)
       || (oformat != E_AU && oformat != E_WAV && oformat != E_AIFF))
      return -1;
    else if (iformat == oformat) {
	SNDpass1chrawdata(infile, outfile, snd, iformat);
	return 1;
    } else {
	cpSNDheaderTrans(&osnd, snd, oformat, iformat);
	x = SNDget1chleveldata(infile, snd, iformat);
	SNDput1chleveldata(outfile, x, &osnd, oformat);
	return 0;
    }
}

int getarg(int argc, char **argv, int *Oformat, FILE **infile,
	   FILE **outfile)
{
    *outfile = stdout;
    *infile = stdin;

    while (--argc > 0) {
	if (**(++argv) == '-') {
	    switch (*(++*argv)) {
	    case 'h':
	    case 'H':
	    case '?': return 0;
	    case 'o':
		if (*outfile != stdout) return -3;
		if (*(++*argv) == '\0') {
		    if (--argc <= 0) return -4; else argv++; 
		}
		if (!strcmp(*argv, "-")) *outfile = stdout;
		else if ((*outfile = fopen(*argv, "w")) == NULL) {
		    fprintf(stderr, "File [%s] open error.\n", *argv);
		    return -5;
		}
		break;
	    case '\0': break;
	    default: return -6;
	    }
	    if (**argv == '\0') { --*argv; break; }
	} else break;
    }
    if (argc < 1 || argc > 2) {
#ifdef DEBUG1
	fprintf(stderr, "DEBUG1: %d\n", argc);
#endif
	return -7;
    }
    if (!strcmp(*argv, "au")) { *Oformat = E_AU; }  
    else if (!strcmp(*argv, "wav")) { *Oformat = E_WAV; }  
    else if (!strcmp(*argv, "aiff")) { *Oformat = E_AIFF; }
    else return -8;
    if (--argc < 1 || !strcmp(*(++argv), "-")
	|| (*infile = fopen(*argv, "r")) != NULL)
      return 1;
    else {
	fprintf(stderr, "File [%s] open error.\n", *argv);
	return -9;
    }
}

void usage(int ret)
{
    char *mess[] = {
	"Usage: sndform (-o [outfile]) [format] ([infile])",
	"   -o [outfile] : ϥեλ (default: ɸ)",
	"   [infile]: ϥե (ά: ɸ)",
	"   [format]: au/wav/aiff",
	" ",
	" [1] ϥեϡ̵ꡢ뤤 '-' ꤷɸ",
	"     Ϥˤʤ롣",
	" [2] ϥեΥǡꤷΤˤ롣",
	" [3] WAV/AIFF -> AU Ѵξ硢Υǡ¿ channel ǡ (",
	"     ƥ쥪) ʤСϤ AU ǡ¿ channel ǡ ˤʤ",
	"     ¿ channel  AU ǡ yomi ΥġǤϥݡȤʤ",
	"     ǡξ sndform  sndmix -nmc  1 channel ǡ ",
	"     (Υ) ˤƤȤ褤",
	NULL
    };
    int j;

#ifdef DEBUG1
    printf("USAGE: %d\n", ret);
#endif
    for (j=0; mess[j]!=NULL; j++)
      fprintf(stderr, "%s\n", mess[j]);
}
