/*
 * ʣβ file  mix 
 * shige
 * 01/04 2003
 * 
 * $Id: sndmix.c,v 1.8 2017-01-20 20:19:21+09 shige Exp $
 *
 * sndmix (-o [outf]) (-mc/-nmc) (-l[x]) (-v[s]) [file1] (-v[s]) [file2] (...)
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "common.h"

#define Maxchannel 10
#define Maxfiles 20

#ifndef Max
# define Max(a, b)  (((a) > (b)) ? (a) : (b))
#endif
#ifndef Abs
# define Abs(a)  Max((a), -(a))
#endif

#define USE_LEVEL_ADJUST

int main(int argc, char *argv[]);
void putoutmix(FILE *infile[], FILE *outfile, SNDheader snd[],
	       int format, double lv[], int ch0, int N, double times);
double getsumpeek(FILE *infile[], SNDheader snd[], int format,
		  double lv[], int ch0, int N);
long int getmaxblocks(SNDheader snd[], int format, int N);
int getchannel(SNDheader snd[], int format, int N);
int getallheader(FILE *infile[], SNDheader snd[], double lv[],
		 int isv[], int N);
int getarg(int argc, char *argv[], FILE **outfile, FILE *infile[],
	   int *mc, double *lo, double lv[], int isv[]);
void usage(int ret);

int main(int argc, char *argv[])
{
    SNDheader snd[Maxfiles], snd0;
    FILE *infile[Maxfiles], *outfile = stdout;
    double lv[Maxfiles + 1], lo, maxl, x;
    int isv[Maxfiles + 1], N, mc, format, ch0;
#ifdef DEBUG1
    int j;
#endif

    if ((N = getarg(argc, argv, &outfile, infile, &mc, &lo, lv, isv))
	<= 0) {
	usage(N); return -N; 
    }
#ifdef DEBUG1
    fprintf(stderr, "(N, mc, lo) = (%d, %d, %f)\n", N, mc, lo);
    for (j=0; j<N; j++)
      fprintf(stderr, "(lv, isv)[%d] = (%f, %d)\n", j, lv[j], isv[j]);
#endif    
    if ((format = getallheader(infile, snd, lv, isv, N)) < 0) { 
	usage(N); return -N; 
    }
#ifdef DEBUG1
    for (j=0; j<N; j++)
      fprintf(stderr, "(lv, isv)[%d] = (%f, %d)\n", j, lv[j], isv[j]);
#endif    
    if (!mc) ch0 = 1;
    else if ((ch0 = getchannel(snd, format, N)) < 0) { 
	usage(ch0); return -ch0; 
    }
#ifdef DEBUG1
    fprintf(stderr, "ch0 = %d\n", ch0);
#endif
#ifdef USE_LEVEL_ADJUST
    if ((maxl = getsumpeek(infile, snd, format, lv, ch0, N)) < 0.0) {
	fprintf(stderr, "getsumpeek() error. (%f)\n", maxl);
	return 30;
    } else if (maxl > 1.0 && lo <= 0.0) lo = 1.0;
#else /* USE_LEVEL_ADJUST */
    if (lo > 0.0 
	&& (maxl = getsumpeek(infile, snd, format, lv, ch0, N)) < 0.0) {
	fprintf(stderr, "getsumpeek() error (%f)\n", maxl);
	return 30;
    }
#endif /* USE_LEVEL_ADJUST */
#ifdef DEBUG1
    if (lo > 0.0) fprintf(stderr, "(lo, maxl) = (%f, %f)\n", lo, maxl);
#endif
    cpSNDheader(&snd0, &snd[0], format);
    setSNDheader(&snd0, format, 0, ch0, 0, 0, 
		 getmaxblocks(snd, format, N), CH_CHANNEL | CH_BLOCKS);
    putSNDheader(outfile, &snd0, format);
		 
    if (maxl == 0.0) x = 0.0;
    else if (lo > 0.0) x = lo/maxl;
    else x = 1.0;
    putoutmix(infile, outfile, snd, format, lv, ch0, N, x);
    return 0;
}

void putoutmix(FILE *infile[], FILE *outfile, SNDheader snd[],
	       int format, double lv[], int ch0, int N, double times)
{
    long int maxblocks, j;
    double x1, x2;
    int k, m, ch[N];

    maxblocks = getmaxblocks(snd, format, N);
    for (k=0; k<N; k++) ch[k] = SNDchannels(&snd[k], format);
    for (j=1; j<=maxblocks; j++) { /* block  */
	if (ch0 > 1) 
	  for (m=1; m<=ch0; m++) { /* channel ˲û */
	      x1 = 0.0;
	      for (k=0; k<N; k++)
		if (j <= SNDblocks(&snd[k], format)) {
		    if (ch[k] == ch0) 
		      x1 += SNDget1chleveldata(infile[k], &snd[k],
					       format) * lv[k];
		    else if (ch[k] == 1) {
			if (m == 1) 
			  x2 = SNDget1chleveldata(infile[k], &snd[k],
						  format) * lv[k];
			x1 += x2;
		    }
		}
	      SNDput1chleveldata(outfile, x1*times, snd, format);
	  } else { /*  channel mix */
	    x1 = 0.0;
	    for (k=0; k<N; k++)
	      if (j <= SNDblocks(&snd[k], format))
		for (m=1; m<=ch[k]; m++)
		  x1 += SNDget1chleveldata(infile[k], &snd[k],
					   format)*lv[k];
	    SNDput1chleveldata(outfile, x1*times, snd, format);
	}
    }
    if (format != E_AU && SNDbitpersmpl(&snd[0], format) == 8
	&& maxblocks%2 && ch0%2)
      fputc(0, outfile);
    return;
}

/* ϡput ¿ʬʬƱ
 */
double getsumpeek(FILE *infile[], SNDheader snd[], int format,
		  double lv[], int ch0, int N)
{
    long int maxblocks, j;
    double max = - 1.0, x1, x2;
    int k, m, ch[N];

    maxblocks = getmaxblocks(snd, format, N);
    for (k=0; k<N; k++) ch[k] = SNDchannels(&snd[k], format);
    for (j=1; j<=maxblocks; j++) { /* block  */
	if (ch0 > 1) 
	  for (m=1; m<=ch0; m++) { /* channel ˲û */
	      x1 = 0.0;
	      for (k=0; k<N; k++)
		if (j <= SNDblocks(&snd[k], format)) {
		    if (ch[k] == ch0) 
		      x1 += SNDget1chleveldata(infile[k], &snd[k],
					       format) * lv[k];
		    else if (ch[k] == 1) {
			if (m == 1) 
			  x2 = SNDget1chleveldata(infile[k], &snd[k],
						  format) * lv[k];
			x1 += x2;
		    } else return -1.0;
		}
	      if (Abs(x1) > max) max = Abs(x1);
	  } else { /*  channel mix */
	    x1 = 0.0;
	    for (k=0; k<N; k++)
	      if (j <= SNDblocks(&snd[k], format))
		for (m=1; m<=ch[k]; m++)
		  x1 += SNDget1chleveldata(infile[k], &snd[k],
					   format) * lv[k];
	    if (Abs(x1) > max) max = Abs(x1);
	}
    }
    for (k=0; k<N; k++)
      fseek(infile[k], SNDhlen(&snd[k], format), SEEK_SET);
    return max;
}

long int getmaxblocks(SNDheader snd[], int format, int N)
{
    long int blocks, max;
    int j;

    if (N <= 0) return 0L;
    max = SNDblocks(&snd[0], format);
    for (j=1; j<N; j++)
      if ((blocks = SNDblocks(&snd[j], format)) > max) max = blocks;
    return max;
}

int getchannel(SNDheader snd[], int format, int N)
{
    int ch, ch0 = -1, j;

    if (N <= 0) return -1;
    if ((ch = SNDchannels(&snd[0], format)) > 1) ch0 = ch;
    for (j=1; j<N; j++)
      if ((ch = SNDchannels(&snd[j], format)) > 1) {
	  if (ch0 > 0) { if (ch != ch0) return -2; }
	  else ch0 = ch;
      }
    return (ch0 < 0) ?  1 : ch0;
}

int getallheader(FILE *infile[], SNDheader snd[], double lv[],
		 int isv[], int N)
{
    int j, format, ret;
    int mask = CH_MAGIC | CH_FMCODE | CH_SMPLRATE | CH_BITPERSMPL;
    double level;

    if ((format = getSNDheader(infile[0], &snd[0])) < 0 
	|| format == E_UNKNOWN) {
        fprintf(stderr, "get header error (%d : %d)\n", 1, format);
        return -1;
    }
    if (!isv[0]) {
	if ((level = SNDgetmaxlevel(infile[0], &snd[0], format)) 
	    <= 0.0) return -2;
	lv[0] /= level;
	isv[0] = 1;
	fseek(infile[0], SNDhlen(snd, format), SEEK_SET);
    }
    for (j=1; j<N; j++) {
	if ((ret = getSNDheader(infile[j], &snd[j])) != format) {
	    fprintf(stderr, "get header error (%d : %d)\n", j, ret);
	    return -1;
	}
	if ((ret = SNDchheaderMASK(&snd[0], &snd[j], format, mask))
	    < 0) {
	    fprintf(stderr, "Headers are different type.\n");
	    return -4;
	}
	if (!isv[j]) {
	    if ((level = SNDgetmaxlevel(infile[j], &snd[j], format))
		<= 0.0) 
	      return -2;
	    lv[j] /= level;
	    isv[j] = 1;
	    fseek(infile[j], SNDhlen(snd, format), SEEK_SET);
	}
    }
    return format;
}

int getarg(int argc, char *argv[], FILE **outfile, FILE *infile[],
	   int *mc, double *lo, double lv[], int isv[])
{
    int N = 0, j;
    double lg = -1.0, vg = -1.0;
   
    *mc = 1;
    *outfile = stdout;
    *lo = -1.0;

    for (j=0; j<=Maxfiles; j++) isv[j]= - 1;

    while (--argc > 0) {
	if (**(++argv) == '-') { /* option */
	    if (!strncmp(*argv, "-o", 2)) {
                if (*outfile != stdout) return -3;
                if (*(*argv += 2) == '\0') { 
		    if (--argc <= 0) return -4; else argv++; 
		}
                if (!strcmp(*argv, "-")) *outfile = stdout;
                else if ((*outfile = fopen(*argv, "w")) == NULL) {
                    fprintf(stderr, "File [%s] open error.\n", *argv);
                    return -5;
                }
	    }
	    else if (!strncmp(*argv, "-mc", 3)) *mc = 1;
	    else if (!strncmp(*argv, "-nmc", 4)) *mc = 0;
	    else if (!strncmp(*argv, "-lo", 3)) {
		if (*(*argv += 3) == '\0') { 
		    if (--argc <= 0) return -4; else argv++; 
		}
		if ((*lo = atof(*argv)) <= 0.0 || *lo > 1.0) return -6;
	    } else if (!strncmp(*argv, "-lg", 3)) {
		if (*(*argv += 3) == '\0') {
		    if (--argc <= 0) return -4; else argv++; 
		}
		if ((lg = atof(*argv)) <= 0.0 || lg > 1.0) return -7;
	    } else if (!strncmp(*argv, "-vg", 3)) {
		if (*(*argv += 3) == '\0') { 
		    if (--argc <= 0) return -4; else argv++; 
		}
		if ((vg = atof(*argv)) <= 0.0 || vg > 1.0) return -8;
	    } else if (!strncmp(*argv, "-v", 2)) {
		if (*(*argv += 2) == '\0') { 
		    if (--argc <= 0) return -4; else argv++; 
		}
		isv[N] = 1;
		if ((lv[N] = atof(*argv)) <= 0.0 || lv[N] > 1.0)
		  return -9;
	    } else if (!strncmp(*argv, "-l", 2)) {
		if (*(*argv += 2) == '\0') {
		    if (--argc <= 0) return -4; else argv++; 
		}
		isv[N] = 0;
		if ((lv[N] = atof(*argv)) <= 0.0 || lv[N] > 1.0)
		  return -10;
	    } else if (*(++*argv) == 'h' || **argv == 'H' 
		       || **argv == '?') return 0;
	    else return -1;
	} else { /* file */
	    if (N >= Maxfiles) return -11;
	    if ((infile[N] = fopen(*argv, "r")) == NULL) {
		fprintf(stderr, "File [%s] open error.\n", *argv);
		return -12;
	    }
	    if (isv[N] < 0) {
		if (vg > 0.0) { isv[N] = 1; lv[N] = vg; }
		else if (lg > 0.0) { isv[N] = 0; lv[N] = lg; }
		else if (N >= 1) {
		    isv[N] = isv[N - 1]; lv[N] = lv[N - 1]; 
		} else { isv[N] = 1; lv[N] = 1.0; }
	    }
	    N ++;
	}
    }
    return N;
}

void usage(int ret)
{
    char *mess[] = {
	"Usage: sndmix [option] [file1] ([option]) [file2] (...)",
	" [option]:",
	"  global option:",
	"   -o [outfile]: ϥեλ (default: ɸ)",
	"   -mc/-nmc: ǡκͥ/Υ (default: -mc)",
	"   -lo[x]: ϥ٥λ (0.0 < [x] <= 1.0)",
	"   -lg[x]: ϥեΥ٥ (0.0 < [x] <= 1.0)",
	"   -vg[x]: ϥեΨ (0.0 < [x] <= 1.0)",
	"  ե option:",
	"   -v[x]: volume Ψ (0.0 < [x] <= 1.0) (default: 1.0)",
	"   -l[x]: volume ٥ (0.0 < [x] <= 1.0) (default: 1.0)",
	"",
	" [1] [file1],[file2],... Υǡñ˲ûΤϤ뤬",
        "     -lo[x] λ꤬ȽϥեΥ٥ [x] 롣",
        "     -lo[x] λ꤬ʤǲûǡ -1.0~1.0 ۤƤޤ",
#ifdef USE_LEVEL_ADJUST
	"     ϡ-1.0~1.0 褦 (-lo1.0 ꤷ褦) ",
	"     롣",
#else /* USE_LEVEL_ADJUST */
	"     ϡΤǤǤꤷ",
#endif /* USE_LEVEL_ADJUST */
	" [2] -v[x] ϡƥǡ volume  [x] ܤˤ (cf. sndvol)",
	"     -l[x] ϡƥǡ volume level  [x] ˤ (cf. sndnormal)",
	"     -lg[x]/-vg[x] λϡƤΥեŬѤ롣",
	"     -v[x]/-l[x] ϡƥǡˤɤ餫Τ߻ꤹ롣",
	" [3] -v[x]/-l[x] λϥե֥ץǡƥե",
	"     եˤĤ뤳ȤǤ롣ץ󤬤ĤƤʤե",
	"     ϡ-lg[x]/-vg[x] ʤϤΥե",
	"     롣㤨",
	"       sndmix  -v0.5 file1 -l0.3 file2 file3",
	"     ξϡfile1  0.5 ܤǡfile2  file3  level 0.3 ǡ",
	"       sndmix -vg0.5 file1 -l0.3 file2 file3",
	"     ξϡfile1  file3  0.5 ܤǡfile2  level 0.3 ",
	"     뤳Ȥˤʤ (-vg  global option)",
	" [4] ʣ channel Υǡ channel ˹뤬channel ",
	"     ΰۤʤǡƱΤι -mc/-nmc ץˤäơ",
	"     channel ˹碌뤫 1 channel ˤ뤫Ǥ (default",
	"     Ϻ) -mc Ϻ channel ñ channel  2 ",
	"      channel ΥǡΤߤꤵƤ˵ǽ",
	"     ʳξ (㤨 2 channel  4 channel Υǡ 1, 2, 3  3",
	"      channel Υǡ) ϥ顼Ȥʤ롣",
	" [5] -v λϡߤ channel ˤĤ뤳ȤϤǤʤΤǡ",
	"     channel  level ѹϡ餫ϥե",
	"      level  channel ĴᤷƤ (cf. sndvol) ϥ",
	"      level  channel Ĵ᤹ (cf. sndvol) ȡ",
	NULL
    };
    int j;

#ifdef DEBUG1
    printf("USAGE: %d\n", ret);
#endif
    for (j=0; mess[j]!=NULL; j++)
      fprintf(stderr, "%s\n", mess[j]);
}
