/* ƬФ tool
 * funa@nolm01.iee.niit.ac.jp, shige
 * 02/24 2001
 * sndslcut.c
 * 
 * $Id: sndslcut.c,v 1.8 2017-03-17 18:02:11+09 shige Exp $
 */
#ifndef __SNDSLCUT_C__
#define __SNDSLCUT_C__

#include "sndslcut.h"

int main(int argc, char *argv[])
{
    int level, cpos[MaxLevel];
    long int ctop[MaxLevel], clast[MaxLevel], pos[MaxDivide + 1];
    int key, ret, isposup, loopend;
    char tmpfnames[MaxDivide + 1][MaxBuff];
    char *minlenstr = NULL, *sndlenstr = NULL;
    Opt opt;
    FILE *infile;
    long int totalblocks, minlen, cblock;

    setdefault(&opt);
    /* command line μ */
    ret = arganal(argc, argv, &opt, &minlenstr, &sndlenstr);
    if (ret < 0) { usage(argv[0]); return 1; }
    /* ѿgraphics ν */
    ret = setinit(&opt, tmpfnames, &infile, minlenstr, sndlenstr);
    if (ret < 0) {
	if (opt.verbose) FPUT1("Initialize error. (%d)\n", ret);
	return 2;
    }
#ifdef DEBUG1
    putopt(&opt);
#endif /* DEBUG1 */
    totalblocks = SNDblocks(&(opt.snd), opt.form);
    minlen = opt.minlen.len;

    level = 0;
    ctop[level] = 0; clast[level] = totalblocks - 1;
    setpos(pos, opt.divide, ctop[level], clast[level], minlen);
    isposup = 1; loopend = 0;
    while (1) {
	putsndgraph(&opt, infile, pos, tmpfnames, isposup);
	key = getkey(opt.putkey, opt.divide); /* key loop */
	switch (key) {
	case '\n': isposup = 0; break; /* κΤ߷֤ */
	case 'q':
	case EOF: cblock = pos[opt.divide - 1]; loopend = 1; break;
	case 'p':
	case 'b':
	case 'f':
	default: 
	    ret = posup(&opt, pos, ctop, clast, cpos, key, &level);
	    if (ret < 0) isposup = -1; /* ưǤʤä */
	    else if (ret == 0) isposup = 1; /* ư */
	    else { /*  */
		cblock = ctop[level];
		loopend = 1;
	    }
	    break;
	}
	if (loopend) break;
    }
    /* ǽ */
    atlast(&opt, infile, cblock, level, ctop, clast, cpos, tmpfnames);
    return 0;
}

/* Ѥ */
void atlast(Opt *opt, FILE *infile, long int cblock, int level,
	    long int ctop[], long int clast[], int cpos[],
	    char tmpfnames[][MaxBuff])
{
    int j;

    if (opt->verbose)
      puthistory(opt, cblock, level, ctop, clast, cpos);
    outputresult(opt, infile, cblock);
    for (j=0; j<=opt->divide; j++) remove(tmpfnames[j]);
    putgraph(NULL, NULL, NULL, 0, 0);
}

/* verbose κǽɽ */
/* Ѥ */
void puthistory(Opt *opt, long int cblock, int level,
		long int ctop[], long int clast[], int cpos[])
{
    int j, divide = opt->divide;
    double dx, smpl = SNDsmplrate(&(opt->snd), opt->form);
    long int n;

    FPUT0("HISTORY:\n");
    for (j=0; j<level; j++) {
	if (opt->usemsec)
	  FPUT3(" [%d]: (TOP, LAST) = (%.1f, %.1f), ", j, 
		Dbk2ms(ctop[j], smpl), Dbk2ms(clast[j], smpl));
	else
	  FPUT3(" [%d]: (TOP, LAST) = (%ld, %ld), ", j, 
		ctop[j], clast[j]);
	dx = (double)(clast[j] - ctop[j])/divide;
	n = ctop[j] + lint45(cpos[j]*dx);
	if (opt->usemsec)
	  FPUT2(" CHOOSE = %d (%.1f)\n", cpos[j], Dbk2ms(n, smpl));
	else FPUT2(" CHOOSE = %d (%ld)\n", cpos[j], n);
    }
    if (opt->usemsec) {
	FPUT3(" [%d]: (TOP, LAST) = (%.1f, %.1f)\n",
	      level, Dbk2ms(ctop[level], smpl), 
	      Dbk2ms(clast[level], smpl));
	FPUT1(" RESULT: %.1f\n", Dbk2ms(cblock, smpl));
    } else {
	FPUT3(" [%d]: (TOP, LAST) = (%ld, %ld)\n", level, 
	      ctop[level], clast[level]);
	FPUT1(" RESULT: %ld\n", cblock);
    }
}

/* ǽ̤ν
 * sndsubstr Ȥ鷺Ǥ
 */ 
/* Ѥ */
int outputresult(Opt *opt, FILE *infile, long int cblock)
{
    FILE *ofile;
    SNDheader *snd0 = &(opt->snd), snd1;
    int form = opt->form, bs, ch, k;
    long int totalblocks, len, j;

#ifdef DEBUG5
    FPUT1("DEBUG5: outfname = %s\n", STRORNULL(opt->outfname));
#endif
    if (! strcmp(opt->outfname, "+")) { fclose(infile); return 0; }
    else if (! strcmp(opt->outfname, "-")) ofile = stdout;
    else if ((ofile = fopen(opt->outfname, "w")) == NULL) {
	fclose(infile); return -1;
    }
    totalblocks = SNDblocks(snd0, form);
    bs = SNDblocksize(snd0, form);
    ch = SNDchannels(snd0, form);
    cpSNDheader(&snd1, snd0, form);
    len = totalblocks - cblock;
    setSNDheader(&snd1, form, 0, 0, 0, 0, len, CH_BLOCKS);
    putSNDheader(ofile, &snd1, form);
    fseek(infile, opt->datapos, SEEK_SET);
    fseek(infile, cblock*bs, SEEK_CUR);
    for (j=1L; j<=len; j++)
      for (k=1; k<=ch; k++) 
	SNDpass1chrawdata(infile, ofile, &snd1, form);
    if (form != E_AU && bs%2 && len%2) fputc(0, ofile);
    if (strcmp(opt->outfname, "-")) fclose(ofile);
    fclose(infile);
    return 0;
}


/* pos[] ιsetpos() 롣
 * return value < 0: pos 򹹿Ǥʤ (Τ)
 *   0: 
 *   1:  (==> ǽλ)
 */ 
/* Ѥ */
int posup(Opt *opt, long int pos[], long int ctop[], long int clast[],
	  int cpos[], int key, int *Level)
{
    int j;
    long int minlen = (opt->minlen).len;
    int ret;

    switch (key) {
    case 'p': /* ľ */
	if (*Level <= 0) {
	    if (opt->verbose) FPUT0("This is TOP level.\n");
	    return -1;
	} else { (*Level) --; break; }
    case 'b': /*  ()  */
	if (*Level <= 0) {
	    if (opt->verbose)
	      FPUT0("Cannot go backward because this is TOP level.\n");
	    return -5;
	} else if (cpos[*Level - 1] <= 1) { 
	    /* ƵŪˤɤʤΤǾ */
	    if (opt->verbose) {
		FPUT0("This is the FIRST position.\n");
		FPUT0("Return to Previous level for going backward.\n");
	    }
	    (*Level) --; break;
	} else {
	    j = -- cpos[*Level - 1];
	    setpos(pos, opt->divide, ctop[*Level - 1], 
		   clast[*Level - 1], minlen);
	    ctop[*Level] = pos[j - 1]; clast[*Level] = pos[j];
	    break;
	}
    case 'f': /* ĸ ()  */
	if (*Level <= 0) {
	    if (opt->verbose)
	      FPUT0("Cannot go forward because this is TOP level.\n");
	    return -10;
	} else if (cpos[*Level - 1] >= opt->divide) {
	    /* ƵŪˤɤʤΤǾ */
	    if (opt->verbose) {
		FPUT0("This is the LAST position.\n");
		FPUT0("Return to Previous level for going forward.\n");
	    }
	    (*Level) --; break;
	} else {
	    j = ++ cpos[*Level - 1];
	    setpos(pos, opt->divide, ctop[*Level - 1], 
		   clast[*Level - 1], minlen);
	    ctop[*Level] = pos[j - 1]; clast[*Level] = pos[j];
	    break;
	}
    default: /* 1  divide δ֤ο */
	if (*Level >= MaxLevel - 1) {
	    if (opt->verbose) FPUT0("Too much level.\n"); 
	    return 1;
	}
	j = cpos[*Level] = key - '0';
	(*Level) ++;
	ctop[*Level] = pos[j - 1]; clast[*Level] = pos[j];
	break;
    }
    ret = setpos(pos, opt->divide, ctop[*Level], clast[*Level], minlen);
    if (ret > 0) {
	if (opt->verbose) FPUT0("Too small cell size.\n");
	(*Level) --;
	return 1;
    }
    return 0;
}

/* Ѥ */
int setpos(long int pos[], int divide, long int ctop, long int clast,
	   long int minsize)
{
    double dx;
    int j;

    if (divide <= 1) return -1;
    if ((dx = (double)(clast - ctop)/divide) < minsize) {
#ifdef DEBUG3
	FPUT0("DEBUG3: (ctop, clast, minsize, dx)");
	FPUT4(" = (%ld, %ld, %ld, %f)\n", ctop, clast, minsize, dx);
#endif
	return 1;
    }
    pos[0] = ctop;
    for (j=1; j<divide; j++) pos[j] = ctop + lint45(j*dx);
    pos[divide] = clast;
    return 0;
}

/* ########## key  ########## */
/* Ѥ */
int getkey(int putkey, int divide)
{
    int get, c;
    
    while (1) { /* key input loop */
	if (putkey) {
	    FPUT0("Hit KEY + enter)\n");
	    FPUT0(" KEY: 1, 2, ... ==> choose 1, 2, ...\n");
	    FPUT0("      q       ==> quit\n");
	    FPUT0("      nothing ==> again\n");
	    FPUT0("      p       ==> previous level\n");
	    FPUT0("      b       ==> backward\n");
	    FPUT0("      f       ==> forward\n");
	}
	get = getchar();
#if 0
	rewind(stdin);
#else
	if (get != '\n') while ((c = getchar()) != '\n' && c != EOF) ;
#endif
	switch (get) {
	case 'q':
	case 'p':
	case 'b':
	case 'f':
	case '\n':
	case EOF: return get;
	default:
	    if (get >= '1' && get <= divide + '0') return get;
	}
    }
}

/* Ѥ */
void putsndgraph(Opt *opt, FILE *infile, long int pos[],
		 char tmpfnames[][MaxBuff], int isposup)
{
    if (isposup < 0) return;
    if (opt->usegraph) {
	if (opt->verbose) FPUT0("Plotting graph...");
	putgraph(opt, infile, pos, isposup, 1);
	if (opt->verbose) FPUT0("completed.\n");
    }
    if (opt->usesound) {
	if (opt->verbose) FPUT0("Putting sound...");
	putsound(opt, infile, pos, tmpfnames, isposup);
	if (opt->verbose) FPUT0("completed.\n");
    }
}

/* ##########  ########## */
/* isposup == 0: pos[] 鹹Ƥʤ 
 * isposup == 1: pos[] 줿
 */ 
/* Ѥ */
void putsound(Opt *opt, FILE *infile, long int pos[],
	      char tmpfnames[][MaxBuff], int isposup)
{
    int divide = opt->divide, k;
    long int sndblock = (opt->sndlen).len;

    /* ʬǡμФ */
    /* 줱ɡƺΤȤϺʤ褦ˤʤ */
    if (isposup) {
#ifdef DEBUG5
	FPUT0("DEBUG5: pos = "); 
	for (k=0; k<=opt->divide; k++) 
	  if (k == 0) FPUT1("(%ld", pos[k]);
	  else FPUT1(",%ld", pos[k]);
	FPUT0(")\n");
#endif
	for (k = 0; k<=divide; k++)
	  mksubsnd(opt, infile, pos[k], sndblock, tmpfnames[k]);
    }
    /* Ϣ &  ==> auconn Ȥ */
    mkconnsnd(opt, tmpfnames);
}

/* Ѥ */
void mkconnsnd(Opt *opt, char tmpfnames[][MaxBuff])
{ 
    char buff[MaxBuff];
    int j;
    long int sndblock = (opt->sndlen).len;

    sprintf(buff, "%s -Lb%ld+", sndconn[opt->form], sndblock);
    for (j=0; j<=opt->divide; j++)
      sprintf(buff, "%s %s %s", buff, opt->poofname, tmpfnames[j]);
    sprintf(buff, "%s %s", buff, opt->playcmd);
#ifdef DEBUG5
    fprintf(stderr, "\n DEBUG5: %s\n", buff);
#endif
    system(buff);
}

/* infile  pos  sndlen  outfname ˽
 */
/* Ѥ */
int mksubsnd(Opt *opt, FILE *infile, long int pos, long int sndlen,
	      char *outfname)
{
    SNDheader snd1, *snd0 = &(opt->snd);
    int form = opt->form;
    int ch = SNDchannels(snd0, form);
    int bs = SNDblocksize(snd0, form);
    int k, flag;
    long int clen, j;
    long int totalblocks = SNDblocks(snd0, form);
    FILE *outfile;

    cpSNDheader(&snd1, snd0, form);
    if (opt->ch > 0) { flag = CH_CHANNEL | CH_BLOCKS; k = 1; }
    else { flag = CH_BLOCKS; k = 0; }
    setSNDheader(&snd1, form, 0, k, 0, 0, sndlen, flag);

    if ((outfile = fopen(outfname, "w")) == NULL) return -1;
    putSNDheader(outfile, &snd1, form);
    fseek(infile, opt->datapos, SEEK_SET);
    if (opt->forward) { /* pos  sndlen block  */
	clen = (sndlen > totalblocks - pos) ? (totalblocks - pos) 
	    : sndlen;
	fseek(infile, pos*bs, SEEK_CUR);
#ifdef DEBUG5
	FPUT2("DEBUG5: (seek-v, seek-p) = (%ld, %ld)\n", 
	      opt->datapos + pos*bs, ftell(infile));
#endif
	for (j=1; j<=clen; j++) 
	  for (k=1; k<=ch; k++) {
	      if (opt->ch == 0 || opt->ch == k) 
		SNDpass1chrawdata(infile, outfile, snd0, form);
	      else SNDskip1chdata(infile, snd0, form);
	  }
	if (sndlen > clen) { /* (sndlen - clen) block null  */
	    clen = sndlen - clen;
	    if (opt->ch == 0) clen = clen*ch;
	    for (j=1; j<=clen; j++)
	      SNDputnull1ch(outfile, snd0, form);
	}
    } else { /* pos ޤ sndlen block  */
	if (sndlen > pos) { /* (sndlen - pos) block null  */
	    clen = sndlen - pos;
	    if (opt->ch == 0) clen = clen*ch;
	    for (j=1; j<=clen; j++)
	      SNDputnull1ch(outfile, snd0, form);
	    clen = pos;
	    pos = 0;
	} else {
	    clen = sndlen;
	    pos -= sndlen;
	    fseek(infile, pos*bs, SEEK_CUR);
	}
	for (j=1; j<=clen; j++) 
	  for (k=1; k<=ch; k++) {
	      if (opt->ch == 0 || opt->ch == k) 
		SNDpass1chrawdata(infile, outfile, snd0, form);
	      else SNDskip1chdata(infile, snd0, form);
	  }
    }
    if (form != E_AU && bs%2 && sndlen%2) fputc(0, outfile);
    fclose(outfile);
    return 0;
}

/* ##########  ########## */
/* sox Ȥ鷺֥եȤ鷺 level ǡϤƤߤ
 */
/* isposup == 0: pos[] 鹹Ƥʤ 
 * isposup == 1: pos[] 줿
 * mode == 1: սϡmode == 0: սλ
 */ 
/* Ѥ */
int putgraph(Opt *opt, FILE *infile, long int pos[], int isposup, 
	      int mode)
{
    static FILE *gp = NULL;
    int ch, k, bs;
    long int j;
    double smpl, x, y, z;

    if (mode == 0) { if (gp != NULL) pclose(gp); return 0; }

    /* gnuplot pipe 򳫤 */
    if (gp == NULL && (gp = popen(GNUPLOT, "w")) == NULL) return -1;
    if (!isposup) {
#if 0
	fprintf(gp, "replot\n");
	fflush(gp);
#endif
	return 0;
    } 
    ch = SNDchannels(&(opt->snd), opt->form);
    bs = SNDblocksize(&(opt->snd), opt->form);
    smpl = SNDsmplrate(&(opt->snd), opt->form);
    /* ǡ */
    setgraph(gp, opt, pos);
    /* fseek */
    fseek(infile, opt->datapos, SEEK_SET);
    fseek(infile, pos[0]*bs, SEEK_CUR);
    /* level ǡ򽦤ä gnuplot ή */
    fprintf(gp, "plot '-' using 1:2 lt 1\n"); 
    for (j=pos[0]; j<=pos[opt->divide]; j++) {
	if (opt->usemsec) x = Dbk2ms(j, smpl);
	else x = j;
	y = 0;
	for (k=1; k<=ch; k++) {
	    z = SNDget1chleveldata(infile, &(opt->snd), opt->form);
	    if (! opt->ch) y += z;
	    else if (opt->ch == k) y = z;
	}
	if (! opt->ch) y = y/ch;
	fprintf(gp, "%f %f\n", x, y);
    }
    fprintf(gp, "e\n");
    /* fflush */
    fflush(gp);
    return 0;
}

/* Ѥ */
void setgraph(FILE *gp, Opt *opt, long int pos[])
{
    int divide = opt->divide, j;
    double smpl = SNDsmplrate(&(opt->snd), opt->form), x, x1, x2;
    double margin = 0.05;

    fprintf(gp, "reset\n");
    fprintf(gp, "set yrange [-1:1]\n");
    fprintf(gp, "set nokey\n");
    fprintf(gp, "set ylabel 'sound level'\n");
    if (opt->usemsec) {
	x1 = Dbk2ms(pos[0], smpl);
	x2 = Dbk2ms(pos[divide], smpl);
	fprintf(gp, "set xlabel 'milii seconds'\n"); 
    } else {
	x1 = pos[0];
	x2 = pos[divide];
	fprintf(gp, "set xlabel 'block number'\n");
    }
    fprintf(gp, "set xrange [%f : %f]\n", x1 - margin*(x2 - x1), 
	    x2 + margin*(x2 - x1));
    for (j=0; j<=divide; j++) {
	x = (opt->usemsec) ? Dbk2ms(pos[j], smpl) : pos[j];
	fprintf(gp, "set arrow %d from %f,-1 to %f,0.9 nohead lt %d\n",
		j + 1, x, x, j + 2);
	fprintf(gp, "set label %d '%d' at %f, 0.93 center\n", 
		j + 1, j + 1, x);
    }
    fprintf(gp, "set xtics");
    for (j=0; j<=divide; j++) {
	if (j == 0) fprintf(gp, " ( ");
	else fprintf(gp, ", ");
	if (opt->usemsec) {
	    x = Dbk2ms(pos[j], smpl);
	    fprintf(gp, "\"%.1f\" %f", x, x);
	} else fprintf(gp, "\"%ld\" %ld", pos[j], pos[j]);
    }
    fprintf(gp, " )\n");
    fprintf(gp, "set pointsize 0.5\n");
    fprintf(gp, "set style data linespoints\n");
}

#ifdef DEBUG1
/* Ѥ */
void putopt(Opt *opt)
{
    FPUT1("DEBUG1: usegraph   = %d\n", opt->usegraph);
    FPUT1("DEBUG1: putkey     = %d\n", opt->putkey);
    FPUT1("DEBUG1: forward    = %d\n", opt->forward);
    FPUT1("DEBUG1: verbose    = %d\n", opt->verbose);
    FPUT1("DEBUG1: usemsec    = %d\n", opt->usemsec);

    FPUT1("DEBUG1: divide     = %d\n", opt->divide);
    FPUT2("DEBUG1: minlen     = (%d, %ld)\n", 
	  (opt->minlen).type, (opt->minlen).len);
    FPUT2("DEBUG1: sndlen     = (%d, %ld)\n",
	  (opt->sndlen).type, (opt->sndlen).len);
    FPUT1("DEBUG1: ch         = %d\n", opt->ch);

    FPUT1("DEBUG1: outfname   = %s\n", STRORNULL(opt->outfname));
    FPUT1("DEBUG1: infname    = %s\n", STRORNULL(opt->infname));
    FPUT1("DEBUG1: tmpd       = %s\n", STRORNULL(opt->tmpd));
    FPUT1("DEBUG1: poofname   = %s\n", STRORNULL(opt->poofname));
    FPUT1("DEBUG1: playcmd    = %s\n", STRORNULL(opt->playcmd));

    FPUT1("DEBUG1: form       = %d\n", opt->form);
    FPUT1("DEBUG1: datapos    = %ld\n", opt->datapos);
}
#endif

/* Ѥ */
void setdefault(Opt *opt)
{
    opt->usegraph = Default_Usegraph;
    opt->usesound = Default_Usesound;
    opt->putkey = Default_Putkey;
    opt->forward = Default_Forward;
    opt->verbose = Default_Verbose;
    opt->usemsec = Default_Usemsec;

    opt->divide = Default_Divide;
    (opt->minlen).type = L_msec;
    (opt->minlen).len = Default_Minlen;
    (opt->sndlen).type = L_msec;
    (opt->sndlen).len = Default_Sndlen;
    opt->ch = Default_Channel;

    opt->outfname = NULL;
    opt->infname = NULL;
    opt->tmpd = Default_Tmpd;
    opt->poofname = Default_Poofname;
    opt->playcmd = NULL;
}

/* ########## command line  ########## */
/* Ѥ */
int arganal(int argc, char *argv[], Opt *opt, char **Minlenstr,
	    char **Sndlenstr)
{
    int j = 1, pos, k = SOP_UNKNOWN;
    char c;

    if (argc < 2) return -1;
    c = *argv[j];
    if (c == '-') {
	c = *(++ argv[j]);
	while (1) {
	    if (c == 'h') { return 1; } /* Help */
	    if (is1cop(c)) { 
		/* 1 ʸoption ʤ */
		switch (c) {
		case 'g': opt->usegraph = 1; break;
		case 'a': opt->usesound = 1; break;
		case 'v': opt->verbose = 1; break;
		case 'k': opt->putkey = 1; break;
		case 'e': opt->forward = 0; break;
		case 'b': opt->usemsec = 0; break;
		}
		if ((c = *(++ argv[j])) != '\0') continue;
	    } else if (c == 'n') {
		/* ε */
		if ((c = *(++ argv[j])) == '\0') return -10;
		if (!is1cop(c)) return -11;
		switch (c) {
		case 'g': opt->usegraph = 0; break;
		case 'a': opt->usesound = 0; break;
		case 'v': opt->verbose = 0; break;
		case 'k': opt->putkey = 0; break;
		case 'e': opt->forward = 1; break;
		case 'b': opt->usemsec = 1; break;
		}
		if ((c = *(++ argv[j])) != '\0') return -12;
	    } else if (c == 'd' || c == 'm' || c == 'l' || c == 'c') {
		/* 1 ʸoption  */
		if (*(++ argv[j]) == '\0' && ++ j >= argc) return -20;
		switch (c) {
		case 'd' : 
		    if ((opt->divide = atoi(argv[j])) < 2 
			|| opt->divide > MaxDivide)
		      return -21;
		    break;
		case 'm': *Minlenstr = argv[j]; break;
		case 'l': *Sndlenstr = argv[j]; break;
		case 'c':
		    if ((opt->ch = atoi(argv[j])) < 0) return -22;
		    break;
		}
	    } else { /* ʸ󥪥ץ */
		/* -o, -tmp, -sh, -sn, -sp */
		if (! strncmp(argv[j], "o", 1)) {
		    pos = 1; k = SOP_O;
		} else if (! strncmp(argv[j], "tmp", 3)) {
		    pos = 3; k = SOP_TMP;
		} else if (! strncmp(argv[j], "sh", 2)) {
		    pos = 2; k = SOP_SH;
		} else if (! strncmp(argv[j], "sn", 2)) {
		    pos = 2; k = SOP_SN;
		} else if (! strncmp(argv[j], "sp", 2)) {
		    pos = 2; k = SOP_SP;
		} else return -30;
		argv[j] += pos;
		if (*argv[j] == '\0' && ++ j >= argc) return -31;
		switch (k) {
		case SOP_O: opt->outfname = argv[j]; break;
		case SOP_TMP: opt->tmpd = argv[j]; break;
		case SOP_SH: opt->poofname = argv[j]; break;
		case SOP_SP: opt->playcmd = argv[j]; break;
		}
	    }
	    if (++ j >= argc) return -41;
	    if (*argv[j] != '-') break;
	    else c = *(++ argv[j]);
	}
    }
    if (j != argc - 1) return -50;
    opt->infname = argv[j];
    return 0;
}


/* ##########  ########## */
/* Ѥ */
int setinit(Opt *opt, char tmpfnames[][MaxBuff],
	    FILE **Infile, char *MinLenstr, char *SndLenstr)
{
    FILE *tmpf;
    double smpl;
    long int blocks;
    
    if ((*Infile = fopen(opt->infname, "r")) == NULL) return -1;
    if ((opt->form = getSNDheader(*Infile, &(opt->snd))) < 0) 
      return -2;
    opt->datapos = ftell(*Infile);
    if (opt->playcmd == NULL) opt->playcmd = sndplay[opt->form];
    mktmpfnames(opt->divide, opt->tmpd, sndext[opt->form], tmpfnames);
    smpl = SNDsmplrate(&(opt->snd), opt->form);

    /* usemsec , string, SndLen  block ñ̤οͤ */
    if (setSndLen(&(opt->minlen), MinLenstr, opt->usemsec, smpl) < 0
	|| setSndLen(&(opt->sndlen), SndLenstr, opt->usemsec, smpl) < 0)
      return -2; 
    blocks = SNDblocks(&(opt->snd), opt->form);
    if (blocks/opt->divide < (opt->minlen).len) return -3;
    if (opt->ch > SNDchannels(&(opt->snd), opt->form)) return -4;

    /* ϥեλå */
    if (opt->outfname == NULL) opt->outfname = "-";
    if (strcmp(opt->outfname, "+") && strcmp(opt->outfname, "-")) {
	if ((tmpf = fopen(opt->outfname, "w")) == NULL) return -5;
	fclose(tmpf);
    }
    return 0;
}


/* lenstr  SndLen  block ñ̤Ѵ¸
 * lenstr == NULL ʤ¸ƤǥեͤѴ
 */
/* Ѥ */
int setSndLen(SndLen *sndlen, char *lenstr, int usemsec, double smpl)
{
    long int j;
    int k, expb = 0;

    if (smpl <= 0.0) return -10;
    if (lenstr != NULL) {
	k = strlen(lenstr);
	if (*(lenstr + k - 1) == 'b') {
	    expb = 1; *(lenstr + k - 1) = '\0';
	}
	if ((j = atol(lenstr)) <= 0L) return -1;
	sndlen->type = L_block;
	if (expb || ! usemsec) sndlen->len = j;
	else sndlen->len = ms2bk(j, smpl);
    } else {
	if (sndlen->type == L_undefined) return -2;
	else if (sndlen->len <= 0L) return -3;
	else if (sndlen->type == L_msec) {
	    sndlen->type = L_block;
	    sndlen->len = ms2bk(sndlen->len, smpl);
	}
    }
    return 0;
}


/* ########## temporary file ̾κ ########## */
/* Ѥ */
void mktmpfnames(int divide, char *tmpd, char *ext, 
		 char tmpfnames[][MaxBuff])
{
    int j;

    for (j=0; j<divide+1; j++)
      sprintf(tmpfnames[j], "%s/%s%d.%s", tmpd, TempFnameHead, j + 1,
	      ext);
}


/* ########## Usage ########## */
/* ۤܺѤߡޤåɬס
 */
void usage(char *name)
{
    FPUT1("Usage: %s ([options]) [datafile]\n", name);
    FPUT0(" [datafile]: ԽϿե\n");
    FPUT0(" [options]:\n");
    FPUT0("    -h: Υå\n");
    FPUT1("    -g/-ng: graph plot 򤹤/ʤ (default: %s)\n",
	  (Default_Usegraph) ? ("") : ("ʤ"));
    FPUT1("    -a/-na: 򤹤/ʤ (default: %s)\n",
	  (Default_Usesound) ? ("") : ("ʤ"));
    FPUT1("    -v/-nv: verbose Ϥ򤹤/ʤ (default: %s)\n",
	  (Default_Verbose) ? ("") : ("ʤ"));
    FPUT1("    -k/-nv: key assign ɽ򤹤/ʤ (default: %s)\n",
	  (Default_Putkey) ? ("") : ("ʤ"));
    FPUT1("    -e/-ne: ̵ʹ/ʹ (default: %s)\n",
	  (Default_Forward) ? ("") : ("̵"));
    FPUT1("    -b/-nb: ñ̤ϥ֥å/ߥ (default: %s)\n",
	  (Default_Usemsec) ? ("ߥ") : ("֥å"));
    FPUT1("    -d [n]    : ʬ (2 <= n<=9, default: %d)\n", 
	  Default_Divide);
    FPUT0("    -m [n]    : ǾĹ (ߥ/֥å:");
    FPUT1(   " default: %ld ms)\n", Default_Minlen);
    FPUT0("    -l [n]    : ץ벻κĹ (ߥ/֥å:");
    FPUT1(" default: %ld ms)\n", Default_Sndlen);
    FPUT0("    -ch [n]   : ͥ (default: ͥ)\n");
    FPUT0("    -o [file] : ϥե (default: ɸ)\n");
    FPUT1("    -tmp [dir]: ȥǥ쥯ȥ (default: %s)\n", 
	  Default_Tmpd);
    FPUT0("    -sh [file]: ƲƬˤĤñ㲻ե̾");
    FPUT1(   " (default: %s)\n", Default_Poofname);
    FPUT0("    -sp [comm]: եκޥ\n");
    FPUT0("1)  -m, - l ñ̤ -b/ - nb ˤäѹ롣\n");
    FPUT0("2)  -o  -o- ==> ɸ, -o+ ==> ̵, ");
    FPUT0(   " λǤ롣\n");
    FPUT1("3)  սϥեȤ [%s] ꤵƤ롣\n", GNUPLOT);
    FPUT0("    ѥ̤äƤʤϡ¹˥ѥꤹ뤳ȡ\n");
    FPUT0("4)  -sp κޥɤˤɸϷͳǲǡήΤǡ\n");
    FPUT0("    Ƭ˥ѥ׵դǰǰϤǻꤹ롣\n");
    FPUT0("    ƤǥեͤϤ줾ʲ̤:\n");
    FPUT1("      AU : \"%s\"\n", AUPLAY);
    FPUT1("      WAV : \"%s\"\n", WAVPLAY);
    FPUT1("      AIFF : \"%s\"\n", AIFFPLAY);
    FPUT0("    ѥ̤äƤʤϡ¹˥ѥꤹ뤳ȡ\n");
}

#endif /* __AUSLCUT_C__ */
