/* 
 * resampling ˤ
 * shige
 * 01/06 2003
 * 
 * $Id: sndspeed.c,v 1.7 2017-01-20 20:22:30+09 shige Exp $
 */
#include <stdio.h>
#include <stdlib.h>
#include "common.h"

#define Mintimes 0.005

int main(int argc, char *argv[]);
int getarg(int argc, char **argv, double *times, FILE **infile,
	   FILE **outfile);
void usage(int ret);

int main(int argc, char *argv[])
{
    FILE *infile, *outfile;
    SNDheader snd, snd0;
    int format, bs, ch, j;
    long int blocks, nblocks;
    double times;
    int ret;
    double svol[MAXChannel], evol[MAXChannel];

    if ((ret = getarg(argc, argv, &times, &infile, &outfile)) <= 0) {
	usage(ret); return -ret;
    }
    if ((format = getSNDheader(infile, &snd)) < 0
	|| format == E_UNKNOWN) {
        fprintf(stderr,"get header error.\n");
        return 3;
    }
    blocks = SNDblocks(&snd, format);
    bs = SNDblocksize(&snd, format);
    if ((ch = SNDchannels(&snd, format)) > MAXChannel) return 4;
    for (j=0; j<ch; j++) svol[j] = evol[j] = 1.0;
    nblocks = blocks/times;
    cpSNDheader(&snd0, &snd, format); 
    if (setSNDheader(&snd0, format, 0, 0, 0, 0, nblocks, CH_BLOCKS) < 0)
      return 5;
    putSNDheader(outfile, &snd, format);
    SNDputtrans(infile, outfile, &snd, format, nblocks, blocks, times,
		0.0, 0.0, svol, evol);
    if (format != E_AU && bs%2 && nblocks%2) fputc(0, outfile);
    return 0;
}


int getarg(int argc, char **argv, double *times, FILE **infile,
	   FILE **outfile)
{
    *outfile = stdout;
    *infile = stdin;
    *times = -1.0;

    while (-- argc > 0) {
	if (**(++ argv) == '-') {
	    switch (*(++ *argv)) {
	    case 'h':
	    case 'H':
	    case '?': return 0;
	    case 'o':
		if (*outfile != stdout) return -3;
		if (*(++ *argv) == '\0') { 
		    if (-- argc <= 0) return -4;
		    else argv ++;
		}
		if(!strcmp(*argv, "-")) *outfile = stdout;
		else if ((*outfile = fopen(*argv, "w")) == NULL) {
		    fprintf(stderr, "File [%s] open error.\n", *argv);
		    return -5;
		}
		break;
	    case '\0': break;
	    default: return -6;
	    }
	    if (**argv == '\0') { -- *argv; break; }
	}
	else break;
    }
    if (argc > 2 || argc < 1) {
#ifdef DEBUG1
	fprintf(stderr,"DEBUG1: %d\n", argc);
#endif
	return -7;
    }
    if ((*times = atof(*argv)) < Mintimes) return -8;
    else if (argc == 1) return 1;
    else if (!strcmp(*(++ argv), "-")) *infile = stdin;
    else if ((*infile = fopen(*argv, "r")) == NULL) {
	fprintf(stderr, "File [%s] open error.\n", *argv);
	return -9;
    }
    return 1;
}

void usage(int ret)
{
    char *mess[] = {
	"Usage: sndspeed (-o [outfile]) [speed] ([infile])",
	"   -o [outfile] : ϥեλ (default: ɸ)",
	"   [speed] : [speed] ®",
	"   [infile]: ϥե (ά: ɸ)",
	" ",
	" [1] ϥեϡꤷʤä硢ӥե̾Ȥ",
	"     '-' ꤷɸϤˤʤ롣",
	" [2] [speed] Ͼͤꤹȡʥե뤬Ƥ",
	"     ޤΤ (ߤ 0.005 ̤ϥ顼ȤƤ)",
	NULL
    };
    int j;

#ifdef DEBUG1
    printf("USAGE: %d\n", ret);
#endif
    for (j=0; mess[j]!=NULL; j++)
      fprintf(stderr, "%s\n", mess[j]);
}
